var WiseStampDialog=function(){var b=this;
var c=WiseStampQuery;
this.name=null;
this.context=null;
this.dialog=null;
this.overlay=null;
this.events={};
this.form={list:{}};
this.navigation={};
this.utils={};
this.location={};
this.variables={};
this.content=null;
this.doc=null;
this.win=null;
this.page=null;
this.open=function(o,d,h,g,p){if(typeof d=="string"&&d.length>0){b.name=d
}else{return false
}o=b.resolve(o);
if(typeof h=="string"){function m(q){if(/^(yes|1)$/.test(q)){return true
}else{if(/^(no|0)$/.test(q)){return false
}else{return q
}}}function j(q){return q.replace(/^\s+/,"").replace(/\s+$/,"")
}var k={};
h.replace(/(?:([^=]+)=([^,]*),?)/g,function(){var q=j(arguments[1]);
if(/^fullscreen$/.test(q)){k[q]=m(arguments[2])
}else{k[q]=arguments[2]
}});
h=k
}else{if(WiseStampUtils.objectKeys(h).length<1){h={}
}}if(g){b.context=c(g)
}else{b.context=c("body")
}b.navigation.initialURL=o;
if(b.context.length==0&&WiseStamp.sys.platform=="mozilla"){var i=Components.classes["@mozilla.org/appshell/appShellService;1"].getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
var n="http://www.w3.org/1999/xhtml";
var f=i.document.createElementNS(n,"div");
f.className="dialog";
f.innerHTML='<iframe type="content" name="'+b.name+'" src="about:blank"></iframe>';
i.document.documentElement.appendChild(f);
b.context=c(i.document.body);
b.content=c(f,i.document)
}else{b.content=c('<div class="dialog"><iframe type="content" name="'+b.name+'" src="about:blank"></iframe></div>');
b.context.prepend(b.content)
}if(h.position=="static"){b.content.addClass("static")
}if(h.position=="top"){b.content.addClass("top")
}if(h.height){b.content.css("height",h.height)
}if(h.width){b.content.css("width",h.width)
}if(h.fullscreen){b.content.addClass("fullscreen")
}if(!h.fullscreen&&h.position!="static"){b.overlay=c('<div class="overlay"></div>');
b.context.append(b.overlay)
}b.variables=p;
for(var e in b.events){b.content.bind(e,b.events[e])
}b.iframe=b.content.find("iframe");
var l=(WiseStamp.sys.platform=="mozilla")?"DOMContentLoaded":"load";
b.iframe[0].addEventListener(l,b.load);
b.iframe[0].addEventListener("load",b.load);
b.navigation.go(o)
};
this.load=function(f){f.stopPropagation();
b.doc=WiseStampUI.getIFrameDocument(b.iframe[0]);
if(typeof b.doc=="undefined"||b.doc==null||WiseStampUtils.isEmpty(b.doc)){return false
}for(var h in b.doc.location){if(typeof b.doc.location[h]=="string"){b.location[h]=b.doc.location[h]
}}b.win=b.window();
b.win.dialog=b;
for(var h in b.variables){b.win[h]=b.variables[h]
}var e=b.utils.$frame();
if(e){var g=WiseStampUtils.queryParameters(b.location.search);
WiseStampTemplateMgr.renderData(b.doc.body,function d(i){if(typeof i=="undefined"){return g
}if(typeof g[i]=="undefined"){return""
}else{return g[i]
}});
e(b.doc).trigger("dialogReady");
b.content.trigger("dialogReady");
e(b.win).bind("beforeunload",function(){b.page=null;
b.content.removeClass("visible");
b.content.removeClass("animate-in");
b.content.addClass("animate-out")
})
}b.utils.adjustDimensions();
b.location.pathname.replace(/([^\/]+)\.([^\.]+)$/,function(i,j){b.page=j
});
b.utils.trackEvent("page",b.page);
b.content.addClass("visible");
b.content.removeClass("animate-out");
b.content.addClass("animate-in")
};
this.close=function(d){if(d!=true){b.utils.trackEvent("skip",b.page)
}if(b.overlay){b.overlay.remove()
}b.iframe.remove();
b.content.remove();
delete b
};
this.window=function(){return b.iframe[0].contentWindow
};
this.resolve=function(d){if(typeof d=="string"&&!d.match(/^[^\?]+:\/\//)){return WiseStamp.getURL(d)
}else{return d
}};
this.on=function(d,e){b.events[d]=e
};
this.form.save=function(){c(b.doc).find("form[name]").each(function(){var d=c(this).attr("name");
var e=b.location.href.replace(WiseStamp.getURL(""),"/");
if(WiseStampUtils.isObjectEmpty(b.form.list[e])){b.form.list[e]={}
}b.form.list[e][d]={};
c(this).find("input[name]").each(function(){var f=c(this).attr("name");
var g=c(this).val();
if(!WiseStampUtils.isEmpty(g)){b.form.list[e][d][f]=g
}})
});
WiseStampController.getStorage().saveParam("formValues",JSON.stringify(b.form.list))
};
this.form.load=function(){WiseStampController.getStorage().loadParam("formValues",function(h){var d={};
var g=b.location.href.replace(WiseStamp.getURL(""),"/");
if(typeof h=="string"){d=JSON.parse(h)
}if(WiseStampUtils.isObjectEmpty(b.form.list)){b.form.list=d
}if(WiseStampUtils.isObjectEmpty(b.form.list[g])){return false
}for(var f in b.form.list[g]){for(var e in b.form.list[g][f]){c(b.doc).find('form[name="'+f+'"] input[name="'+e+'"]:not([data-loadsaved="false"])').val(b.form.list[g][f][e])
}}})
};
this.form.getSavedQueryByForm=function(d,e){WiseStampController.getStorage().loadParam("formValues",function(i){if(WiseStampUtils.isEmpty(i)){e({});
return false
}var f={};
if(typeof i=="string"){f=JSON.parse(i)
}if(WiseStampUtils.isObjectEmpty(b.form.list)){b.form.list=f
}var g=c(b.doc).find('head link[rel="prev"]').attr("href");
for(var h in b.form.list){if(h.indexOf(g)==0){e(b.form.list[h][d]);
return true
}}e({});
return false
})
};
function a(d){var e=b.navigation.get(d);
if(d=="next"){var f=b.navigation.mainForm();
if(f.length>0){b.utils.$frame()(f).submit()
}else{b.navigation.go(e)
}}else{b.navigation.go(e)
}}this.navigation.mainForm=function(){return c(b.doc).find("form.main-form, form:eq(0)").eq(0)
};
this.navigation.next=function(){a("next")
};
this.navigation.prev=function(){a("prev")
};
this.navigation.go=function(d){if(typeof d=="string"&&d!=""){b.iframe.attr("src",b.resolve(d))
}};
this.navigation.get=function(d){var e=c(b.doc).find('link[rel="'+d+'"]').attr("href");
if(!WiseStampUtils.isEmpty(e)){if(e.substr(0,1)=="/"){e=e.substr(1)
}return b.resolve(e)
}else{return false
}};
this.navigation.index=function(){var g={};
var f=c(b.doc).find("link[rel]");
for(var h=0;
h<f.length;
h++){var j=f.eq(h);
var d=j.attr("rel");
var e=j.attr("href");
if(!WiseStampUtils.isEmpty(d,e)){if(WiseStamp.sys.platform=="mozilla"){e="/content"+e
}g[d]=e
}}if(!WiseStampUtils.isEmpty(g)){return g
}else{return false
}};
this.navigation.meta=function(){var e=[];
var k=c(b.doc).find("meta[name]");
for(var f=0;
f<k.length;
f++){var j=k.eq(f);
var d=j.attr("name");
var g=j.attr("content");
var h={};
h[d]=g;
e.push(h)
}if(!WiseStampUtils.isEmpty(e)){return e
}else{return false
}};
this.utils.$frame=function(){if("defaultView" in b.doc){return b.doc.defaultView.$
}else{if("parentWindow" in b.doc){return b.doc.parentWindow.$
}}};
this.utils.adjustDimensions=function(d,k){if(k){c(k).each(function(m,n){c(n).load(function(){b.utils.adjustDimensions(d)
})
});
return true
}if(typeof d=="object"){do{d.dialog.utils.adjustDimensions();
d=d.parent
}while(d.dialog)
}else{if(!b.doc){return false
}var g=c(b.doc.body.parentNode);
var h=c(b.doc.body);
var f=window.getComputedStyle(h[0],null);
var l=g.height();
var e=parseFloat(f.marginLeft)+h.outerWidth(false)+parseFloat(f.marginRight);
var j=2;
var i=window.getComputedStyle(b.iframe[0],null);
if(i){if(i.borderTop){l+=parseFloat(i.borderTop)
}else{l+=j
}if(i.borderBottom){l+=parseFloat(i.borderBottom)
}else{l+=j
}if(i.borderLeft){e+=parseFloat(i.borderLeft)
}else{e+=j
}if(i.borderRight){e+=parseFloat(i.borderRight)
}else{e+=j
}}b.content.height(l);
b.content.width(e)
}};
this.utils.trackEvent=function(){var d=Array.prototype.slice.call(arguments)
}
};