var WiseStampUtils=new function(){var d=this;
this.REMOTE_LOGGING=false;
this.FILE_LOGGING=false;
var f={};
var c=0;
this.mLogFile=null;
this.init=function(){WiseStampUtils.log("[WiseStampUtils::init] platform - "+WiseStamp.sys.platform);
switch(WiseStamp.sys.platform){case"mozilla":var i=new WiseStampMozillaPrefs("extensions.wisestamp2");
this.REMOTE_LOGGING=i.getPrefValue("remote_log");
this.FILE_LOGGING=i.getPrefValue("file_log");
break;
case"chrome":case"safari":this.REMOTE_LOGGING=(typeof localStorage.remote_log!="undefined")&&localStorage.remote_log;
this.FILE_LOGGING=(typeof localStorage.file_log!="undefined")&&localStorage.file_log;
break
}};
function h(s,j,i,q){var n={Error:s,File:j,Line:i};
var m="";
for(var r in n){if(!WiseStampUtils.isEmpty(n[r])){m+=r+": "+n[r]+" <br />"
}}WiseStampUtils.log(m);
WiseStampUtils.trackError(m);
var k=WiseStampQuery('<a style="text-decoration: underline" href="javascript:void(0)" class="report">Report this bug</a>');
k.click(function(){WiseStampEditor.onSubmitBug(m)
});
msg=WiseStampQuery('<div><span>Ok, we really hoped this wouldn\'t happen...</span><br/><br/><pre style="font-size: 85%; font-family: inherit;">'+m+"</pre><br/><br/></div>");
msg.append(k);
function p(){WiseStampUI.showPopup(msg,undefined,undefined,undefined,460)
}if(q==true){var o=WiseStampQuery('<div class="statusbar-icon"></div>');
o.click(function(){p();
o.remove()
});
var l=WiseStampQuery('<img src="../img/wisestamp_error.png">');
l.attr("title",m.replace("<br />","\n"));
o.append(l);
WiseStampQuery("#statusbar").prepend(o)
}else{p()
}}this.catchGlobalExceptions=function(){window.onerror=function(j,k,i){if(j.indexOf("nsIDOMNSHTMLDocument.domain")!=-1){return
}if(k.indexOf("jquery")!=-1){return
}h(j,k,i)
}
};
var b=0;
this.traceFn=function(i,j){return function(){var p="";
for(var n=0;
n<b;
n++){p+="__"
}WiseStampUtils.log(p+"["+i+"] >>>>>");
var m=[];
for(var l in arguments){var o=""+arguments[l];
o=o.replace(/\n/g,"");
o=o.replace(/\s+/g," ");
if(o.length>20){o=o.substr(0,20)+"..."
}m.push("("+o+")")
}WiseStampUtils.log(p+"["+i+"]"+m.join(", "));
b++;
var k=j.apply(this,arguments);
b--;
WiseStampUtils.log(p+"["+i+"] <<<<<");
return k
}
};
this.wrapWithTrace=function(j,i){if(WiseStamp.config.debug==false){return
}for(var k in j){if(typeof j[k]!="function"){continue
}j[k]=WiseStampUtils.traceFn(i+"::"+k,j[k])
}};
this.wrapWithCatch=function(k,j){function i(m,n){return function(){try{var o=n.apply(this,arguments);
return o
}catch(q){var p=q.message+" (Error in "+m+")";
h(p,q.fileName,q.lineNumber)
}}
}for(var l in k){if(typeof k[l]!="function"){continue
}k[l]=k[l]=i(j+"::"+l,k[l])
}};
this.trackError=function(k){var j=(typeof k=="string"&&k.length>0);
if(!j){k="could not get error message. type: "+(typeof k)
}var i=k.substr(0,50);
i=i.replace("#","");
i=i.replace("&","");
i=WiseStampUtils.urlencode(i);
WiseStampAnalytics.trackEvent("error",i,WiseStampUtils.base64_encode(k))
};
this.logError=function(j,i){this.log(j,i)
};
this.log=function(o,l){if(WiseStamp.config.debug==false){return l
}o=(new Date()).toLocaleTimeString()+" WISESTAMP: "+o;
switch(WiseStamp.sys.platform){case"conduit":if(typeof JSInjection!="undefined"&&WiseStamp.context=="editor"){JSInjection('if (typeof console != "undefined") console.log("'+o.replace('"',"","g")+'");')
}if(this.REMOTE_LOGGING==true){this.REMOTE_LOGGING=false;
this.getRemoteData({type:"GET",url:"local.wisestamp/logging",params:"msg="+o,success:function(p){WiseStampUtils.REMOTE_LOGGING=true
}})
}break;
case"ie":log(o);
break;
case"mozilla":if(typeof this.mConsoleService=="undefined"){this.mConsoleService=Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService)
}this.mConsoleService.logStringMessage(o);
if(this.FILE_LOGGING){if(this.mLogFile==null){var j=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
j.initWithPath("c:\\temp\\wisestamp.log");
var m=Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
m.init(j,2|8|32,438,0);
var k=Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
k.init(m,"UTF-8",0,0);
this.mLogFile=k
}this.mLogFile.writeString(o+"\r\n")
}break
}if(typeof console!="undefined"){console.log(o)
}if(this.REMOTE_LOGGING==true){var n={};
n["entry.0.single"]=this.mRandomID;
n["entry.1.single"]=o;
var i="https://spreadsheets0.google.com/formResponse?formkey=dHpZZ2pJMTl4SWJiM3o2d1gzTExyenc6MQ&amp;ifq";
WiseStampQuery.post(i,n)
}return l
};
this.assert=function(n,m){if(WiseStamp.config.debug||WiseStampUser.isTester()){if(!n){var j="[ASSERTION] "+(m?m:"!")+"\n[ASSERTION] Stack:\n";
var i=new Error().stack;
if(typeof i!="undefined"){var k=WiseStampUtils.getUrl("");
k=k.replace(/([.^$+(){}\[\]\\|])/g,"\\$1");
var l=new RegExp(k,"g");
i=i.replace(l,"");
i=i.split(/\n/);
j+=i.map(function(o){return o
}).join("\n")
}else{j+="Unavailable"
}h(j,"","",true)
}}return n
};
this.openWindow=function(j,i,s,k){WiseStampUtils.log("[WiseStampUtils::openWindow] url="+j+" >>>>>");
if(typeof i!="undefined"){var l="utm_source="+i+"&utm_medium="+s+"&utm_campaign="+k;
if(j.indexOf("?")==-1){l="?"+l
}else{l="&"+l
}if(j.indexOf("#")==-1){j+=l
}else{j=j.replace("#",l+"#")
}}switch(WiseStamp.sys.platform){case"mozilla":if(WiseStamp.sys.application=="Firefox"){var r=Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
var n=r.getMostRecentWindow("navigator:browser");
if(n){n.getBrowser().selectedTab=n.getBrowser().addTab(j);
n.focus()
}else{n=window.open(j);
n.focus()
}}else{if(WiseStamp.sys.email_client){try{var o=Components.classes["@mozilla.org/messenger;1"].createInstance();
o=o.QueryInterface(Components.interfaces.nsIMessenger);
o.launchExternalURL(j)
}catch(p){}}}break;
case"chrome":chrome.tabs.create({url:j});
break;
case"safari":if(typeof safari.application!="undefined"){safari.application.activeBrowserWindow.openTab("foreground").url=j
}else{var m={command:"openWindow",url:j};
safari.self.tab.dispatchMessage("request",m)
}break;
case"conduit":if(WiseStamp.context=="editor"){window.open(j,"WiseStamp")
}else{NavigateInNewTab(j);
if(typeof WiseStampEditor!="undefined"){window.setTimeout(WiseStampEditor.onCancel,1000)
}}break;
case"web":var q=window.open(j,"WiseStamp");
q.focus();
break
}};
this.openDialog=function(o,q,j,m){WiseStampUtils.log("[WiseStampUtils::openWindow] "+o+" >>>>>");
var p=null;
if(typeof OpenGadget!="undefined"){var l=["resizable=yes","scrollbars=no","closebutton=yes","closeonexternalclick=no","savelocation=no","saveresizedsize=no","openposition=center"];
OpenGadget(o,m+"px",j+"px",l.join(","))
}else{var n=(window.screen.height-j)/2-50;
var r=(window.screen.width-m)/2;
var i="height="+j+",width="+m+",left="+r+",top="+n;
var k=window.open;
if(WiseStamp.sys.email_client){k=window.openDialog
}p=k(o,q,i+",toolbar=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no,location=no");
if(WiseStamp.sys.platform!="safari"){p.focus()
}}return p
};
this.findWindow=function(o,q){WiseStampUtils.log("[WiseStampUtils::findWindow] >>>>>");
switch(WiseStamp.sys.platform){case"mozilla":var p=Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
var i=p.getEnumerator(null);
while(i.hasMoreElements()){var l=i.getNext();
if(("gBrowser" in l)==false){if(l.document.documentURI.indexOf(o)!=-1){q(l);
return
}continue
}var k=l.gBrowser;
if(("browsers" in k)==false){continue
}var j=k.browsers.length;
WiseStampUtils.log("[WiseStampUtils::findWindow] a window, tabs number = "+j);
for(var n=0;
n<j;
n++){var m=k.getBrowserAtIndex(n);
WiseStampUtils.log("[WiseStampUtils::findWindow] "+m.currentURI.spec);
if(m.currentURI.spec.indexOf(o)!=-1){q(k.tabContainer.childNodes[n]);
return
}}}q(null);
break;
case"chrome":chrome.windows.getAll({populate:true},function(u){for(var t=0;
t<u.length;
t++){var s=u[t];
for(var r=0;
r<s.tabs.length;
r++){if(s.tabs[r].url.indexOf(o)!=-1){q(s.tabs[r]);
return
}}}q(null)
});
break;
default:q(null);
break
}};
this.alert=function(m,l){switch(WiseStamp.sys.platform){case"mozilla":if(typeof l=="undefined"){l="WiseStamp"
}var i=Components.classes;
var k=Components.interfaces;
var j=i["@mozilla.org/embedcomp/prompt-service;1"].getService(k.nsIPromptService);
j.alert(window,l,m);
break;
case"chrome":case"ie":case"safari":alert(m);
break
}};
this.getUrl=function(j,i){return WiseStamp.getURL(j,i)
};
this.onResponse=function(i,j){WiseStampUtils.log("[WiseStampUtils::onResponse] >>>>>");
this.mResponseMap[i](JSON.parse(j));
delete this.mResponseMap[i]
};
this.sendRequest=function(j,m){if(typeof m=="undefined"){m=function(n){}
}switch(WiseStamp.sys.platform){case"web":case"conduit":if(typeof WS_MSG_FUNC=="undefined"){WiseStampUtils.log("[WiseStampUtils::sendRequest] msg func not set");
break
}j.msg_id=parseInt(Math.random()*100000);
if(("mResponseMap" in this)==false){this["mResponseMap"]={}
}this.mResponseMap[j.msg_id]=function(n){WiseStampUtils.log("[WiseStampUtils::sendRequest] got response");
m(n)
};
var i={request:j,sendResponse:function(n){m(n)
}};
WS_MSG_FUNC(JSON.stringify(i));
break;
case"mozilla":WiseStampUtils.assert(typeof WiseStampMsgHandler!="undefined","WiseStampUtils.sendRequest cannot be accessed from the Editor on the Mozilla platform");
if(typeof WiseStampMsgHandler!="undefined"){WiseStampMsgHandler.handle(j,m)
}break;
case"chrome":chrome.extension.sendRequest(j,m);
break;
case"safari":var i=j;
i.msg_id=Math.random(99999);
if(typeof this.mResponseMap=="undefined"){this.mResponseMap={};
var l=this;
safari.self.addEventListener("message",function(n){l.mResponseMap[n.name](n.message);
delete l.mResponseMap[n.name]
},false)
}this.mResponseMap[i.msg_id]=m;
safari.self.tab.dispatchMessage("request",i);
break;
case"ie":switch(type){case"all":var k=WiseStampDbStorage.getDefaultData();
k.signatures[1].html="<br/><p>Personal signature</p>";
k.signatures[1].socialServices[0].value="x";
k.signatures[1].socialServices[1].value="x";
k.signatures[2].html="<br/><p>Business signature</p>";
k.signatures[2].socialServices[2].value="x";
k.signatures[2].socialServices[3].value="x";
m(k);
break;
case"signature":m(WiseStampSignature.getHtml(this.mData,param));
break
}break
}};
this.getStackTrace=function(){var r=[];
var l=false;
try{m.dont.exist+=0
}catch(o){if(o.stack){var s=o.stack.split("\n");
for(var m=0,n=s.length;
m<n;
m++){r.push(s[m])
}r.shift();
l=true
}else{if(window.opera&&o.message){var s=o.message.split("\n");
for(var m=0,n=s.length;
m<n;
m++){var q=s[m];
if(s[m+1]){q+=" at "+s[m+1];
m++
}r.push(q)
}r.shift();
l=true
}}}if(!l){var k=arguments.callee.caller;
while(k){var p=k.toString();
var j=p.substring(p.indexOf("function")+8,p.indexOf(""))||"anonymous";
r.push(j);
k=k.caller
}}return r
};
this.md5=function(w){function P(x,k){return(x<<k)|(x>>>(32-k))
}function O(H,x){var ad,k,G,I,F;
G=(H&2147483648);
I=(x&2147483648);
ad=(H&1073741824);
k=(x&1073741824);
F=(H&1073741823)+(x&1073741823);
if(ad&k){return(F^2147483648^G^I)
}if(ad|k){if(F&1073741824){return(F^3221225472^G^I)
}else{return(F^1073741824^G^I)
}}else{return(F^G^I)
}}function v(k,G,F){return(k&G)|((~k)&F)
}function u(k,G,F){return(k&F)|(G&(~F))
}function t(k,G,F){return(k^G^F)
}function r(k,G,F){return(G^(k|(~F)))
}function z(G,F,ae,ad,k,H,I){G=O(G,O(O(v(F,ae,ad),k),I));
return O(P(G,H),F)
}function j(G,F,ae,ad,k,H,I){G=O(G,O(O(u(F,ae,ad),k),I));
return O(P(G,H),F)
}function L(G,F,ae,ad,k,H,I){G=O(G,O(O(t(F,ae,ad),k),I));
return O(P(G,H),F)
}function y(G,F,ae,ad,k,H,I){G=O(G,O(O(r(F,ae,ad),k),I));
return O(P(G,H),F)
}function i(H){var ae;
var G=H.length;
var F=G+8;
var x=(F-(F%64))/64;
var ad=(x+1)*16;
var af=Array(ad-1);
var k=0;
var I=0;
while(I<G){ae=(I-(I%4))/4;
k=(I%4)*8;
af[ae]=(af[ae]|(H.charCodeAt(I)<<k));
I++
}ae=(I-(I%4))/4;
k=(I%4)*8;
af[ae]=af[ae]|(128<<k);
af[ad-2]=G<<3;
af[ad-1]=G>>>29;
return af
}function J(F){var x="",G="",H,k;
for(k=0;
k<=3;
k++){H=(F>>>(k*8))&255;
G="0"+H.toString(16);
x=x+G.substr(G.length-2,2)
}return x
}function N(x){x=x.replace(/\r\n/g,"\n");
var k="";
for(var G=0;
G<x.length;
G++){var F=x.charCodeAt(G);
if(F<128){k+=String.fromCharCode(F)
}else{if((F>127)&&(F<2048)){k+=String.fromCharCode((F>>6)|192);
k+=String.fromCharCode((F&63)|128)
}else{k+=String.fromCharCode((F>>12)|224);
k+=String.fromCharCode(((F>>6)&63)|128);
k+=String.fromCharCode((F&63)|128)
}}}return k
}var K=Array();
var T,m,M,A,l,ac,ab,aa,Z;
var W=7,U=12,R=17,Q=22;
var E=5,D=9,C=14,B=20;
var s=4,q=11,p=16,o=23;
var Y=6,X=10,V=15,S=21;
w=N(w);
K=i(w);
ac=1732584193;
ab=4023233417;
aa=2562383102;
Z=271733878;
for(T=0;
T<K.length;
T+=16){m=ac;
M=ab;
A=aa;
l=Z;
ac=z(ac,ab,aa,Z,K[T+0],W,3614090360);
Z=z(Z,ac,ab,aa,K[T+1],U,3905402710);
aa=z(aa,Z,ac,ab,K[T+2],R,606105819);
ab=z(ab,aa,Z,ac,K[T+3],Q,3250441966);
ac=z(ac,ab,aa,Z,K[T+4],W,4118548399);
Z=z(Z,ac,ab,aa,K[T+5],U,1200080426);
aa=z(aa,Z,ac,ab,K[T+6],R,2821735955);
ab=z(ab,aa,Z,ac,K[T+7],Q,4249261313);
ac=z(ac,ab,aa,Z,K[T+8],W,1770035416);
Z=z(Z,ac,ab,aa,K[T+9],U,2336552879);
aa=z(aa,Z,ac,ab,K[T+10],R,4294925233);
ab=z(ab,aa,Z,ac,K[T+11],Q,2304563134);
ac=z(ac,ab,aa,Z,K[T+12],W,1804603682);
Z=z(Z,ac,ab,aa,K[T+13],U,4254626195);
aa=z(aa,Z,ac,ab,K[T+14],R,2792965006);
ab=z(ab,aa,Z,ac,K[T+15],Q,1236535329);
ac=j(ac,ab,aa,Z,K[T+1],E,4129170786);
Z=j(Z,ac,ab,aa,K[T+6],D,3225465664);
aa=j(aa,Z,ac,ab,K[T+11],C,643717713);
ab=j(ab,aa,Z,ac,K[T+0],B,3921069994);
ac=j(ac,ab,aa,Z,K[T+5],E,3593408605);
Z=j(Z,ac,ab,aa,K[T+10],D,38016083);
aa=j(aa,Z,ac,ab,K[T+15],C,3634488961);
ab=j(ab,aa,Z,ac,K[T+4],B,3889429448);
ac=j(ac,ab,aa,Z,K[T+9],E,568446438);
Z=j(Z,ac,ab,aa,K[T+14],D,3275163606);
aa=j(aa,Z,ac,ab,K[T+3],C,4107603335);
ab=j(ab,aa,Z,ac,K[T+8],B,1163531501);
ac=j(ac,ab,aa,Z,K[T+13],E,2850285829);
Z=j(Z,ac,ab,aa,K[T+2],D,4243563512);
aa=j(aa,Z,ac,ab,K[T+7],C,1735328473);
ab=j(ab,aa,Z,ac,K[T+12],B,2368359562);
ac=L(ac,ab,aa,Z,K[T+5],s,4294588738);
Z=L(Z,ac,ab,aa,K[T+8],q,2272392833);
aa=L(aa,Z,ac,ab,K[T+11],p,1839030562);
ab=L(ab,aa,Z,ac,K[T+14],o,4259657740);
ac=L(ac,ab,aa,Z,K[T+1],s,2763975236);
Z=L(Z,ac,ab,aa,K[T+4],q,1272893353);
aa=L(aa,Z,ac,ab,K[T+7],p,4139469664);
ab=L(ab,aa,Z,ac,K[T+10],o,3200236656);
ac=L(ac,ab,aa,Z,K[T+13],s,681279174);
Z=L(Z,ac,ab,aa,K[T+0],q,3936430074);
aa=L(aa,Z,ac,ab,K[T+3],p,3572445317);
ab=L(ab,aa,Z,ac,K[T+6],o,76029189);
ac=L(ac,ab,aa,Z,K[T+9],s,3654602809);
Z=L(Z,ac,ab,aa,K[T+12],q,3873151461);
aa=L(aa,Z,ac,ab,K[T+15],p,530742520);
ab=L(ab,aa,Z,ac,K[T+2],o,3299628645);
ac=y(ac,ab,aa,Z,K[T+0],Y,4096336452);
Z=y(Z,ac,ab,aa,K[T+7],X,1126891415);
aa=y(aa,Z,ac,ab,K[T+14],V,2878612391);
ab=y(ab,aa,Z,ac,K[T+5],S,4237533241);
ac=y(ac,ab,aa,Z,K[T+12],Y,1700485571);
Z=y(Z,ac,ab,aa,K[T+3],X,2399980690);
aa=y(aa,Z,ac,ab,K[T+10],V,4293915773);
ab=y(ab,aa,Z,ac,K[T+1],S,2240044497);
ac=y(ac,ab,aa,Z,K[T+8],Y,1873313359);
Z=y(Z,ac,ab,aa,K[T+15],X,4264355552);
aa=y(aa,Z,ac,ab,K[T+6],V,2734768916);
ab=y(ab,aa,Z,ac,K[T+13],S,1309151649);
ac=y(ac,ab,aa,Z,K[T+4],Y,4149444226);
Z=y(Z,ac,ab,aa,K[T+11],X,3174756917);
aa=y(aa,Z,ac,ab,K[T+2],V,718787259);
ab=y(ab,aa,Z,ac,K[T+9],S,3951481745);
ac=O(ac,m);
ab=O(ab,M);
aa=O(aa,A);
Z=O(Z,l)
}var n=J(ac)+J(ab)+J(aa)+J(Z);
return n.toLowerCase()
};
this.utf8_encode=function(i){var q=(i+"");
var r="",j,m,k=0;
j=m=0;
k=q.length;
for(var l=0;
l<k;
l++){var p=q.charCodeAt(l);
var o=null;
if(p<128){m++
}else{if(p>127&&p<2048){o=String.fromCharCode((p>>6)|192)+String.fromCharCode((p&63)|128)
}else{o=String.fromCharCode((p>>12)|224)+String.fromCharCode(((p>>6)&63)|128)+String.fromCharCode((p&63)|128)
}}if(o!==null){if(m>j){r+=q.slice(j,m)
}r+=o;
j=m=l+1
}}if(m>j){r+=q.slice(j,k)
}return r
};
this.base64_encode=function(q){var m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
var l,k,j,u,t,s,r,v,p=0,w=0,o="",n=[];
if(!q){return q
}q=WiseStampUtils.utf8_encode(q+"");
do{l=q.charCodeAt(p++);
k=q.charCodeAt(p++);
j=q.charCodeAt(p++);
v=l<<16|k<<8|j;
u=v>>18&63;
t=v>>12&63;
s=v>>6&63;
r=v&63;
n[w++]=m.charAt(u)+m.charAt(t)+m.charAt(s)+m.charAt(r)
}while(p<q.length);
o=n.join("");
switch(q.length%3){case 1:o=o.slice(0,-2)+"==";
break;
case 2:o=o.slice(0,-1)+"=";
break
}return o
};
var g=[{string:navigator.userAgent,subString:"Chrome",identity:"Chrome"},{string:navigator.userAgent,subString:"OmniWeb",versionSearch:"OmniWeb/",identity:"OmniWeb"},{string:navigator.vendor,subString:"Apple",identity:"Safari",versionSearch:"Version"},{prop:window.opera,identity:"Opera"},{string:navigator.vendor,subString:"iCab",identity:"iCab"},{string:navigator.vendor,subString:"KDE",identity:"Konqueror"},{string:navigator.userAgent,subString:"Firefox",identity:"Firefox"},{string:navigator.vendor,subString:"Camino",identity:"Camino"},{string:navigator.userAgent,subString:"Netscape",identity:"Netscape"},{string:navigator.userAgent,subString:"MSIE",identity:"Explorer",versionSearch:"MSIE"},{string:navigator.userAgent,subString:"Gecko",identity:"Mozilla",versionSearch:"rv"},{string:navigator.userAgent,subString:"Mozilla",identity:"Netscape",versionSearch:"Mozilla"}];
function e(m){for(var j=0;
j<m.length;
j++){var k=m[j].string;
var l=m[j].prop;
this.versionSearchString=m[j].versionSearch||m[j].identity;
if(k){if(k.indexOf(m[j].subString)!=-1){return m[j].identity
}}else{if(l){return m[j].identity
}}}}function a(k){var j=k.indexOf(this.versionSearchString);
if(j==-1){return
}var i=k.substring(j+this.versionSearchString.length+1);
if(i.indexOf(" ")!=-1){i=i.substring(0,i.indexOf(" "))
}return i
}this.getBrowserType=function(){return e(g)||"unknown"
};
this.getBrowserVersion=function(){return a(navigator.userAgent)||a(navigator.appVersion)||"unknown"
};
this.mozIterateCookies=function(k,m){k=k.replace(/^http:\/\//,"");
k=k.replace(/\/$/,"");
var l=Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager);
var i=l.enumerator;
while(i.hasMoreElements()){var j=i.getNext();
if(j instanceof Components.interfaces.nsICookie){if(j.host==k){if(m(j,l)){break
}}}}};
this.parseCookieString=function(k){if(k!=null){var m=k.split("; ");
var l={};
for(var j=0;
j<m.length;
j++){var i=m[j].split("=");
l[i[0]]=i[1]
}return l[name]
}};
this.getCookies=function(l,k,m){var i={};
var j=WiseStampUtils.wildcardToRegex(k);
switch(WiseStamp.sys.platform){case"mozilla":WiseStampUtils.mozIterateCookies(l,function(n){if(j.test(n.name)){i[n.name]=n.value
}});
m(i);
break;
case"chrome":chrome.cookies.getAll({url:l},function(q){for(var o=0;
o<q.length;
o++){var n=q[o].name;
var p=q[o].value;
if(j.test(n)){i[n]=p
}}m(i)
});
break;
default:m(i)
}};
this.setCookie=function(i,n){var j=new Date();
var k=(j.getTime()/1000)+(60*60*24);
switch(WiseStamp.sys.platform){case"mozilla":var l="";
if(!i.domain){l=WiseStampUtils.prop_by_path(i,"url","");
l=l.replace(/^http:\/\//,"");
l=l.replace(/\/$/,"")
}else{l=i.domain
}var m=Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager2);
m.add(l,"/",i.name,i.value,false,false,false,k);
break;
case"chrome":i.expirationDate=k;
chrome.cookies.set(i,n);
break;
default:n(null)
}};
this.readCookie=function(j,i,k){switch(WiseStamp.sys.platform){case"mozilla":WiseStampUtils.mozIterateCookies(j,function(l){if(l.name==i){k({value:l.value});
return true
}});
break;
case"chrome":chrome.cookies.get({url:j,name:i},k);
break;
default:k(null)
}};
this.removeCookie=function(j,i,k){switch(WiseStamp.sys.platform){case"mozilla":WiseStampUtils.mozIterateCookies(j,function(l,m){if(l.name==i){m.remove(j,i,"/",false);
k({url:j,name:i});
return true
}});
break;
case"chrome":chrome.cookies.remove({url:j,name:i},k);
break;
default:k(null)
}};
this.xmlToObject=function(k){var j={};
j.nodeCount=k.childNodes.length;
if(!k.hasChildNodes()){return j
}for(var l=0;
l<k.childNodes.length;
l++){var m=k.childNodes[l];
switch(m.nodeType){case 1:if(j.nodes==undefined){j.nodes={}
}if(typeof j.nodes[m.tagName]=="undefined"){j.nodes[m.tagName]=[]
}j.nodes[m.tagName].push(this.xmlToObject(m));
break;
case 2:if(j.attributes==undefined){j.attributes={}
}j.attributes[m.tagName]=m.nodeValue;
break;
case 3:case 4:j.text=m.nodeValue;
break
}}return j
};
this.getRemoteData=function(l){if(l.addRandomParam!=false&&"data" in l&&l.data.length>0){l.data+="&r="+Math.floor(Math.random()*10000)
}if(WiseStamp.sys.platform=="conduit"){var i=l.url;
if(i.indexOf("http")==0&&i.split("/").length==3){i=i+"/"
}var n=(l.type=="GET")?null:l.data;
if(l.type=="GET"&&typeof l.data!="undefined"&&l.data!=""){i+="?"+l.data
}CrossDomainHttpRequest(function(u,t){if(t==200){l.success(u)
}else{WiseStampUtils.log("[WiseStampUtils::getRemoteData] error "+t+" for url = "+i);
l.error(null,"Error "+t)
}},l.type,i,n);
return
}if(WiseStamp.sys.platform=="web"){var q=l.url;
var o="http://";
if(q.substr(0,o.length)==o){q=q.substr(o.length)
}l.url=WiseStamp.config.URLs.APIs.proxy;
if(l.type=="GET"){if("data" in l&&l.data.length>0){l.data="url="+encodeURIComponent(q+"?"+l.data)
}else{l.data="url="+encodeURIComponent(q)
}}else{l.url+="?url="+encodeURIComponent(q)
}}WiseStampUtils.log("[WiseStampUtils::getRemoteData] url = "+l.url+" >>>>>");
function s(){var t=(c+1)%100;
f[t]={};
f[t].isFree=false;
c=t;
return t
}function j(t){WiseStampUtils.log("[WiseStampUtils::getXmlHttpObject] iXmlHttp = "+t);
if(f[t]==null){WiseStampUtils.log("[WiseStampUtils::getXmlHttpObject] NULL!! iXmlHttp = "+t)
}return f[t]
}function m(t){WiseStampUtils.log("[WiseStampUtils::releaseXmlHttpObject] iXmlHttp = "+t);
f[t]=null
}function r(t){var u=j(t).xmlhttp;
var x=j(t).success;
WiseStampUtils.log("[getRemoteData::callback] iXmlHttp="+t+", readyState="+u.readyState+", status="+u.status);
if(u.readyState!=4){return null
}if(u.status!=200){var w=u.status;
try{w=w+" ("+u.statusText+")"
}catch(v){}j(t).error(u,w,null);
m(t);
return null
}x(u.responseText,u.getResponseHeader("Content-Type"),u.responseXML);
m(t)
}var k=s();
j(k).xmlhttp=new XMLHttpRequest();
j(k).success=l.success;
j(k).error=l.error;
var i=l.url;
var n=(l.type=="GET")?null:l.data;
if(l.type=="GET"&&typeof l.data!="undefined"&&l.data!=""){i+="?"+l.data
}j(k).xmlhttp.open(l.type,i,true);
if(n!=null){j(k).xmlhttp.setRequestHeader("Content-type","application/x-www-form-urlencoded");
j(k).xmlhttp.setRequestHeader("Content-length",n.length);
j(k).xmlhttp.setRequestHeader("Connection","close");
j(k).xmlhttp.setRequestHeader("Referer","http://www.wisestamp.com")
}try{WiseStampUtils.log("[getRemoteData] xmlhttp.send; iXmlHttp="+k);
j(k).xmlhttp.send(n);
j(k).xmlhttp.onreadystatechange=function(){r(k)
}
}catch(p){j(k).error(j(k),p.message,null)
}};
this.fetchTemplated=function(){var m={url:arguments[0]};
for(var l=1;
typeof arguments[l]=="string";
l++){m.url=m.url.replace(/<[^>]+>/,arguments[l])
}var k=m.url.split("?");
m.url=k[0];
m.data=k[1]||"";
var j={};
if(typeof arguments[arguments.length-1]=="object"){j=arguments[arguments.length-1];
if(typeof j.onSuccess!="function"){j.onSuccess=function(){}
}if(typeof j.onError!="function"){j.onError=function(){}
}}WiseStampUtils.getRemoteData({url:m.url,type:"GET",data:m.data,success:function(q,t,s){WiseStampUtils.log("[WiseStampUtils::fetchTemplated] got data!");
try{var n=j.dataType;
var p;
if(n=="xml"){if(s instanceof Object){p=WiseStampQuery(s)
}else{var i=WiseStampQuery.parseXML(q);
p=WiseStampQuery(i);
n="malformed-xml"
}}else{if(n=="json"){p=WiseStampUtils.jsonParse(q)
}else{if(n=="auto"||typeof n=="undefined"){if(s instanceof Object){p=WiseStampQuery(s);
n="xml"
}else{var o=WiseStampUtils.jsonParse(q);
if(o!=null){p=o;
n="json"
}else{var i=WiseStampQuery.parseXML(q);
p=WiseStampQuery(i);
n="malformed-xml"
}}}}}j.onSuccess(p,n,t)
}catch(r){j.onError({type:"parse",data:q,contentType:t});
WiseStampUtils.log("[WiseStampUtils::fetchTemplated] failed to parse data, exception = "+r)
}},error:function(i,q,p){WiseStampUtils.log("[WiseStampUtils::fetchTemplated] failed to get data, error = "+q);
j.onError({type:"network",XMLHttpRequest:i,textStatus:q,errorThrown:p});
try{var n=JSON.parse(i.responseText);
if("error" in n){WiseStampUtils.log("[WiseStampUtils::fetchTemplated] got error - ["+n.error+"]")
}}catch(o){}}})
};
this.parseDataByType=function(m,o,l){var n={};
var j=function(p,q){};
switch(o){case"xml":case"malformed-xml":j=function(q,s){var r=s.split(/(?:@)([^@]+)$/);
if(r.length>1){var p=r[1],s=r[0];
return q.find(s).eq(0).attr(p)
}else{var t=q.find(s).eq(0).text();
if(o=="malformed-xml"){return WiseStampUtils.strip_tags(t)
}else{return t
}}};
break;
case"json":j=function(p,q){return WiseStampUtils.prop_by_path(p,q)
};
break
}function i(q){for(var p in q){var s=q[p];
var r=j(m,s);
if(r){n[p]=r
}}}if(l instanceof Object){i(l)
}else{var k;
if(o=="xml"||o=="malformed-xml"){if(m.find("rss > channel").length>0){k="rss"
}else{if(m.find("feed > entry").length>0){k="atom"
}}}switch(k){case"rss":i({feed_item_title:"channel item title",feed_item_link:"channel item link",feed_item_desc:"channel item description"});
break;
case"atom":i({feed_item_title:"feed entry title",feed_item_link:"feed entry link@href",feed_item_desc:"feed entry summary"});
break;
default:return WiseStampUtils.parseError("missing custom response descriptor")
}}return n
};
this.parseError=function(i){var j=new Error(i);
j.name="ParseError";
return j
};
this.jsonStringify=function(j){try{return JSON.stringify(j)
}catch(i){WiseStampUtils.log("[WiseStampUtils::jsonParse] failed to stringify");
return null
}};
this.jsonParse=function(k,i){try{return JSON.parse(k)
}catch(j){if(typeof i=="undefined"){i=null
}WiseStampUtils.log("[WiseStampUtils::jsonParse] failed to parse - "+k);
return i
}};
this.parseHeaders=function(i){var j={};
i.replace(/\b(?:([^\:]+)\s?\:\s?([^\n]*)\n?)/g,function(){j[arguments[1]]=arguments[2]
});
return j
};
this.urlencode=function(i){i=(i+"").toString();
return encodeURIComponent(i).replace(/%/g,"%25").replace(/!/g,"%21").replace(/#/g,"%23").replace(/\$/g,"%24").replace(/&/g,"%26").replace(/'/g,"%27").replace(/\(/g,"%28").replace(/\)/g,"%29").replace(/\*/g,"%2A").replace(/\+/g,"%2B").replace(/\,/g,"%2C").replace(/\//g,"%2F").replace(/\:/g,"%3A").replace(/\;/g,"%3B").replace(/\=/g,"%3D").replace(/\?/g,"%3F").replace(/\@/g,"%40").replace(/\[/g,"%5B").replace(/\]/g,"%5D").replace(/%20/g,"+")
};
this.urldecode=function(i){return decodeURIComponent((i+"").replace(/\+/g,"%20"))
};
this.queryParameters=function(j,l){if(typeof j=="undefined"){j=document.location.search
}else{if(l){j=j.replace(/^[^\?]+/,"")
}}var i=j.split("#");
if(i.length>1){WiseStampUtils.assert(false,"Fragment identifier stripped off URI in WiseStampUtils.queryParameters");
j=i[0]
}var k={};
j.replace(/\??(?:([^=]+)=([^&]*)&?)/g,function(){function o(p){var q=p;
try{q=decodeURIComponent(q);
q=unescape(q).split("+").join(" ")
}catch(t){}q=q.replace(/\n/g,"");
var r=WiseStampUtils.jsonParse(q);
if(r instanceof Object){q=r
}return q
}var m=o(arguments[1]),n=o(d.urldecode(arguments[2]));
if(m.substr(-2)=="[]"){m=m.substr(0,m.length-2);
if(k[m] instanceof Array){k[m].push(n)
}else{k[m]=[n]
}}else{k[m]=n
}});
return k
};
this.queryString=function(p){var j=[],o="";
function l(i,q){if(typeof q=="undefined"){q=""
}else{if(q instanceof Object){q=WiseStampUtils.jsonStringify(q)
}}j.push(i+"="+d.urlencode(q))
}for(var k in p){var n=p[k];
if(n instanceof Array){for(var m=0;
m<n.length;
m++){l(k+"[]",n[m])
}}else{l(k,n)
}}if(j.length){o="?"+j.join("&")
}return o
};
this.queryMerge=function(j,m){var n=WiseStampUtils.queryParameters(j,true);
for(var i in n){m[i]=n[i]
}var k=WiseStampUtils.queryString(m);
var l=WiseStampUtils.prop_by_path(j.split("#"),"1","");
if(l.length){l="#"+l
}j=j.split("?")[0];
j=j+k+l;
return j
};
this.abbreviate=function(i){i=i.replace(/ all /ig," ol ");
i=i.replace(/ and /ig," n ");
i=i.replace(/ are /ig," R ");
i=i.replace(/ be /ig," B ");
i=i.replace(/ Before /ig," B4 ");
i=i.replace(/ Busy /ig," BZ ");
i=i.replace(/ By The Way /ig," BTW ");
i=i.replace(/ Bye Bye for Now /ig," BB4N ");
i=i.replace(/ for /ig," 4 ");
i=i.replace(/ Nice To Know /ig," NTK ");
i=i.replace(/ Night /ig," N8 ");
i=i.replace(/ Oh By The Way /ig," OBTW ");
i=i.replace(/ thank you /ig," 10Q ");
i=i.replace(/ the /ig," d ");
i=i.replace(/ to /ig," 2 ");
i=i.replace(/ you /ig," U ");
i=i.replace(/ your /ig," UR ");
return(i)
};
this.strip_tags=function(i,k){k=(((k||"")+"").toLowerCase().match(/<[a-z][a-z0-9]*>/g)||[]).join("");
var j=/<\/?([a-z][a-z0-9]*)\b[^>]*>/gi,l=/<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi;
return i.replace(l,"").replace(j,function(n,m){return k.indexOf("<"+m.toLowerCase()+">")>-1?n:""
})
};
this.date=function(q,l){if(!isNaN(Number(l))){l=new Date(Number(l))
}var m={days:["Sun","Mon","Tues","Wednes","Thurs","Fri","Satur"],months:["January","February","March","April","May","June","July","August","September","October","November","December"],format:{}};
var o=l.getDate();
var i=o;
if(o.length==1){i="0"+o
}var k=l.getMonth();
var n=k;
if(k.length==1){n="0"+k
}var r="pm";
if(l.getHours()<12){r="am"
}var p=l.getHours();
if(p!=12){p=p%12
}var j=String(l.getMinutes());
if(j.length==1){j="0"+j
}m.format.d=i;
m.format.j=o;
m.format.F=m.months[k];
m.format.m=n;
m.format.M=m.months[k].substr(0,3);
m.format.g=p;
m.format.i=j;
m.format.a=r;
m.format.Y=l.getFullYear();
return q.replace(/.{1}/g,function(s){if(WiseStampUtils.prop_by_path(m,"format."+s)){return m.format[s]
}else{return s
}})
};
this.strtotime=function(p,k){var n,o,t,r="",l="";
r=p;
r=r.replace(/\s{2,}|^\s|\s$/g," ");
r=r.replace(/[\t\r\n]/g,"");
if(r=="now"){return(new Date()).getTime()/1000
}else{if(!isNaN(l=Date.parse(r))){return(l/1000)
}else{if(k){k=new Date(k*1000)
}else{k=new Date()
}}}r=r.toLowerCase();
var m={day:{sun:0,mon:1,tue:2,wed:3,thu:4,fri:5,sat:6},mon:{jan:0,feb:1,mar:2,apr:3,may:4,jun:5,jul:6,aug:7,sep:8,oct:9,nov:10,dec:11}};
var j=function(i){var v=(i[2]&&i[2]=="ago");
var u=(u=i[0]=="last"?-1:1)*(v?-1:1);
switch(i[0]){case"last":case"next":switch(i[1].substring(0,3)){case"yea":k.setFullYear(k.getFullYear()+u);
break;
case"mon":k.setMonth(k.getMonth()+u);
break;
case"wee":k.setDate(k.getDate()+(u*7));
break;
case"day":k.setDate(k.getDate()+u);
break;
case"hou":k.setHours(k.getHours()+u);
break;
case"min":k.setMinutes(k.getMinutes()+u);
break;
case"sec":k.setSeconds(k.getSeconds()+u);
break;
default:var s;
if(typeof(s=m.day[i[1].substring(0,3)])!="undefined"){var w=s-k.getDay();
if(w==0){w=7*u
}else{if(w>0){if(i[0]=="last"){w-=7
}}else{if(i[0]=="next"){w+=7
}}}k.setDate(k.getDate()+w)
}}break;
default:if(/\d+/.test(i[0])){u*=parseInt(i[0],10);
switch(i[1].substring(0,3)){case"yea":k.setFullYear(k.getFullYear()+u);
break;
case"mon":k.setMonth(k.getMonth()+u);
break;
case"wee":k.setDate(k.getDate()+(u*7));
break;
case"day":k.setDate(k.getDate()+u);
break;
case"hou":k.setHours(k.getHours()+u);
break;
case"min":k.setMinutes(k.getMinutes()+u);
break;
case"sec":k.setSeconds(k.getSeconds()+u);
break
}}else{return false
}break
}return true
};
o=r.match(/^(\d{2,4}-\d{2}-\d{2})(?:\s(\d{1,2}:\d{2}(:\d{2})?)?(?:\.(\d+))?)?$/);
if(o!=null){if(!o[2]){o[2]="00:00:00"
}else{if(!o[3]){o[2]+=":00"
}}t=o[1].split(/-/g);
for(n in m.mon){if(m.mon[n]==t[1]-1){t[1]=n
}}t[0]=parseInt(t[0],10);
t[0]=(t[0]>=0&&t[0]<=69)?"20"+(t[0]<10?"0"+t[0]:t[0]+""):(t[0]>=70&&t[0]<=99)?"19"+t[0]:t[0]+"";
return parseInt(this.strtotime(t[2]+" "+t[1]+" "+t[0]+" "+o[2])+(o[4]?o[4]/1000:""),10)
}var q="([+-]?\\d+\\s(years?|months?|weeks?|days?|hours?|min|minutes?|sec|seconds?|sun\\.?|sunday|mon\\.?|monday|tue\\.?|tuesday|wed\\.?|wednesday|thu\\.?|thursday|fri\\.?|friday|sat\\.?|saturday)|(last|next)\\s(years?|months?|weeks?|days?|hours?|min|minutes?|sec|seconds?|sun\\.?|sunday|mon\\.?|monday|tue\\.?|tuesday|wed\\.?|wednesday|thu\\.?|thursday|fri\\.?|friday|sat\\.?|saturday))(\\sago)?";
o=r.match(new RegExp(q,"gi"));
if(o==null){return false
}for(n=0;
n<o.length;
n++){if(!j(o[n].split(" "))){return false
}}return(k.getTime()/1000)
};
this.objectKeys=function(k){var j=[];
for(var i in k){j.push(i)
}return j
};
this.in_array=function(m,l,k){var j="",i=!!k;
if(i){for(j in l){if(l[j]===m){return true
}}}else{for(j in l){if(l[j]==m){return true
}}}return false
};
this.HTMLToText=function(j){var i={"<":"&lt;",">":"&gt;"};
return j.replace(/[<>]/g,function(k){return i[k]
})
};
this.htmlspecialchars=function(l,q,p,k){var n=0,m=0,o=false;
if(typeof q==="undefined"||q===null){q=2
}l=l.toString();
if(k!==false){l=l.replace(/&/g,"&amp;")
}l=l.replace(/</g,"&lt;").replace(/>/g,"&gt;");
var j={ENT_NOQUOTES:0,ENT_HTML_QUOTE_SINGLE:1,ENT_HTML_QUOTE_DOUBLE:2,ENT_COMPAT:2,ENT_QUOTES:3,ENT_IGNORE:4};
if(q===0){o=true
}if(typeof q!=="number"){q=[].concat(q);
for(m=0;
m<q.length;
m++){if(j[q[m]]===0){o=true
}else{if(j[q[m]]){n=n|j[q[m]]
}}}q=n
}if(q&j.ENT_HTML_QUOTE_SINGLE){l=l.replace(/'/g,"&#039;")
}if(!o){l=l.replace(/"/g,"&quot;")
}return l
};
this.htmlspecialchars_decode=function(k,o){var m=0,l=0,n=false;
if(typeof o==="undefined"){o=2
}k=k.toString().replace(/&lt;/g,"<").replace(/&gt;/g,">");
var j={ENT_NOQUOTES:0,ENT_HTML_QUOTE_SINGLE:1,ENT_HTML_QUOTE_DOUBLE:2,ENT_COMPAT:2,ENT_QUOTES:3,ENT_IGNORE:4};
if(o===0){n=true
}if(typeof o!=="number"){o=[].concat(o);
for(l=0;
l<o.length;
l++){if(j[o[l]]===0){n=true
}else{if(j[o[l]]){m=m|j[o[l]]
}}}o=m
}if(o&j.ENT_HTML_QUOTE_SINGLE){k=k.replace(/&#0*39;/g,"'")
}if(!n){k=k.replace(/&quot;/g,'"')
}k=k.replace(/&amp;/g,"&");
return k
};
this.get_value_from_path=function(k,j,i){if(i==j.length){return k
}return WiseStampUtils.get_value_from_path(k[j[i]]||{},j,i+1)
};
this.update_path=function(l,k,i,j){if(i==k.length){return j
}l[k[i]]=WiseStampUtils.update_path(l[k[i]]||{},k,i+1,j);
return l
};
this.wildcardToRegex=function(j){var i=j;
i=i.replace(/([.^$+(){}\[\]\\|])/g,"\\$1");
i=i.replace(/\*/g,".*");
return new RegExp(i)
};
this.isEmpty=function(){for(var j=0;
j<arguments.length;
j++){if(typeof arguments[j]=="undefined"){return true
}if(arguments[j]==null){return true
}if(arguments[j]===false){return true
}if(typeof arguments[j].length=="number"&&arguments.length==0){return true
}if(arguments[j]===""){return true
}}};
this.isObjectEmpty=function(i){return WiseStampUtils.objectKeys(i).length==0
};
this.isInt=function(i){return !isNaN(parseInt(i))
};
this.props=function(s,w){if(s===null){alert("props called with null argument","error");
return
}if(s===undefined){alert("props called with undefined argument","error");
return
}var u=["Methods","Fields","Unreachables"];
var n=[[],[],[]];
var m,q,r;
var k=0;
for(m=s;
m;
m=m.__proto__){for(r=0;
r<u.length;
++r){n[r][k]=[]
}++k
}for(var v in s){var o=-1;
try{for(m=s;
m&&(v in m);
m=m.__proto__){++o
}}catch(x){o=0
}var t=1;
try{if((typeof s[v])=="function"){t=0
}}catch(x){t=2
}n[t][o].push(v)
}function l(i,j){return j?i+l(i,j-1):""
}for(q=0;
q<k;
++q){for(r=0;
r<u.length;
++r){if(n[r][q].length){alert(u[r]+l(" of prototype",q)+": "+(w?"\n\n":"")+n[r][q].sort().join(w?"\n":", ")+(w?"\n\n":""))
}}}};
this.shorten=function(k,i){var j=k;
k=k.replace(/^([^\.]+\.\s)(.*)/,"$1");
if(k.length>i){k=k.substr(0,i)
}if(k.length<j.length){k+="..."
}return k
};
this.capitalize=function(i){if(typeof i!="string"){return i
}return i.substr(0,1).toUpperCase()+i.substr(1)
};
this.chr=function(i){if(i>65535){i-=65536;
return String.fromCharCode(55296+(i>>10),56320+(i&1023))
}return String.fromCharCode(i)
};
this.outerHTML=function(i){return i.outerHTML||(function(l){var k=document.createElement("div"),j;
k.appendChild(l.cloneNode(true));
j=k.innerHTML;
k=null;
return j
})(i)
};
this.move_caret=function(m,j,k){var l=m.getSelection(),i=l.getRangeAt(0);
i.selectNode(j);
i.collapse(k)
};
this.prop_by_path=this.pbp=function(l,k,i,m){var j=WiseStampUtils.parse_path_string(k,m);
return WiseStampUtils.get_object_property_by_path_array(l,j,i)
};
this.parse_path_string=function(l,n){if(!(n instanceof Object)){n={}
}if(typeof l=="string"){l=l.replace(/\[([^\]]+)\]/g,".$1");
if(l.substr(0,1)=="."){l=l.substr(1)
}var m=l.split(".");
for(var j=1;
j<m.length;
j++){var k=n[m[j]];
if(typeof k=="string"||WiseStampUtils.isInt(k)){m[j]=k
}}return m
}else{return[]
}};
this.stringify_path_array=function(i){return i.join(".")
};
this.get_object_property_by_path_array=function(k,j,i){if(j.length==0){if(typeof k=="undefined"){return i
}else{return k
}}var m=j.shift();
for(var l in k){if(l==m||(typeof k=="object"&&m in k)){return arguments.callee(k[m],j,i)
}else{return i
}}};
this.isHigherVersion=function(k,j){k=k.split(".");
j=j.split(".");
for(var l=0;
l<k.length;
l++){if(l>j.length){return false
}if(k[l]!=j[l]){return parseInt(k[l])>parseInt(j[l])
}}return false
};
this.addMozillaSharing=function(j){function i(p){try{if(p==null){return
}var n={};
var m=WiseStampUtils.objectKeys(p);
for(var l=0;
l<m.length;
l++){var k=m[l];
n[k]="rw";
var q=p[k];
if(typeof q=="object"){i(q)
}}p.__exposedProps__=n
}catch(o){}}i(j)
}
};
WiseStampUtils.init();