var WiseStampAppTodayInHistory=new function(){this.TYPE="todayInHistory";
this.TITLE="Today In History";
this.DESCRIPTION="Share the historical significance of the day!";
this.CATEGORIES=["content"];
this.SOURCE="Wikipedia";
this.SUPPORTEDSTYLES={compact:{}};
this.createNew=function(){var a=new this.instance;
a.setAppName(this.TITLE);
a.setAppSource(this.SOURCE);
a.setAppTitle(this.TITLE);
a.setSupportedStyles(this.SUPPORTEDSTYLES);
a.setType(this.TYPE);
return a
};
this.instance=function(){var a=this;
this.mParams={};
this.mRefreshable=true;
this.mRefreshInterval=6*24*60*60*1000;
this.getSettingsHtml=function(){return"This App will update daily with the historical significance of the day"
};
this.refreshDataInternal=function(c){var b=[];
WiseStampUtils.getRemoteData({url:"http://en.wikipedia.org/w/index.php?title=Wikipedia:Selected_anniversaries/June_25&action=render",type:"GET",success:function(d){WiseStampUtils.log("[WiseStampAppTodayInHistory::refreshDataInternal] got data!");
try{if(typeof d!="string"){return c(false)
}d=d.replace(/<img[^>]*>/g,"");
d=WiseStampQuery("<div>"+d+"</div>").find("ul:last li");
d.each(function(e){if(!/^\s*\d\d/.test(d.eq(e).text())){return true
}var g={};
g.link=d.eq(e).find("b a, strong a").eq(0).attr("href").replace(/^\/\//,"http://");
g.description=WiseStampUtils.strip_tags(d.eq(e).html(),"<b><strong><em><i>");
b.push(g)
});
a.mCache=b;
c(true)
}catch(f){WiseStampUtils.log("[WiseStampAppTodayInHistory::refreshDataInternal] failed to parse data, exception = "+f);
c(false);
return
}c(true)
},error:function(d,h,g){WiseStampUtils.log("[WiseStampAppTodayInHistory::refreshDataInternal] failed to get data, error = "+h);
try{WiseStampUtils.log("[WiseStampAppTodayInHistory::refreshDataInternal] got error - ["+data.error+"]")
}catch(f){}c(false)
}})
};
this.getHtml=function(i){if(this.mCache==null){if(typeof i=="function"){return i("")
}else{return""
}}var f=Math.round(Math.random()*(a.mCache.length-1));
var g=a.mCache[f];
var e=g.link;
var d=g.description;
var h=WiseStampUtils.strip_tags(g.description);
var c={content:[],actions:[],styles:{}};
c.content.push({text:"Today in History:<br />",fontSize:"90%",color:"gray"});
c.content.push({text:h,link:e,color:"black",textDecoration:"underline"});
c.icon={source:"todayInHistory_32.png",link:e};
c.facebookLink={sharedUrl:e,linkText:"Share",linkColor:"#578CCA;",delimiter:'<span style="color: gray;"> &bull; </span>'};
c.twitterLink={tweetText:"Today:"+h,linkText:"Tweet",linkColor:"#578CCA;"};
c.styles.compact={icon:{source:"todayInHistory.png",width:"16px"}};
var b=this.renderHtml(c);
if(typeof i=="function"){i(b)
}else{return b
}}
};
this.instance.prototype=new WiseStampAppRssBase
};