var WiseStampMozillaStorage=function(){var d=null;
var c="extensions.wisestamp2";
var b="extensions.wisestamp";
var a=new WiseStampMozillaPrefs(c);
this.init=function(e){WiseStampUtils.log("[WiseStampMozillaStorage::init] >>>");
e()
};
this.saveParam=function(g,h,f){WiseStampUtils.log("[WiseStampMozillaStorage::saveParam] param = "+g+", value = "+h+", type = "+f);
try{if(typeof f=="undefined"){if(typeof h=="object"){h=JSON.stringify(h)
}a.mPrefsBranch.setCharPref(g,h)
}else{if(f=="complex"){a.setComplexPref(g,h)
}}}catch(i){WiseStampUtils.log("[WiseStampMozillaStorage.js::saveParam param="+g+", value="+h+", error = "+i)
}};
this.loadParam=function(g,j,f){var h=null;
try{if(f=="complex"){h=a.getComplexPref(g)
}else{h=a.mPrefsBranch.getCharPref(g)
}}catch(i){WiseStampUtils.log("[WiseStampMozillaStorage.js::loadParam param="+g+", value="+h+", error = "+i)
}if(h=="true"||h=="false"){h=(h=="true")
}if(f=="json"){h=(h==null)?{}:WiseStampUtils.jsonParse(h)
}if(typeof j!="undefined"){j(h)
}return h
};
this.reset=function(){a.clearBranch(c);
a.clearBranch(b)
};
this.getVersion=function(f){var e=this.loadParam("version");
if(typeof f!="undefined"){f(e)
}return e
};
this.saveVersion=function(e){this.saveParam("version",e)
};
this.saveSignature=function(k,f){var j=this;
var g="signatures."+k+".";
function h(p,o){var q=g+p;
var m=0;
for(var n in o){var l=o[n];
j.saveParam(q+"."+n+".id",l.id);
j.saveParam(q+"."+n+".val",l.value);
m++
}j.saveParam(q+".count",m)
}function e(o){var n=g+"widgets.";
var m=0;
for(var l in o){var q=o[l];
for(var p in q){if(p=="params"){continue
}j.saveParam(n+l+"."+p,q[p])
}j.saveParam(n+l+".value",JSON.stringify(q.params));
m++
}j.saveParam(n+"count",m)
}for(var i in f){switch(i){case"socialServices":case"imServices":case"widgets":continue;
case"title":case"socialLabel":case"html":this.saveParam("signatures."+k+"."+i,f[i],"complex");
break;
default:this.saveParam("signatures."+k+"."+i,f[i]);
break
}}h("social",f.socialServices);
h("im",f.imServices);
e(f.widgets)
};
this.loadSignature=function(j){var i=this;
var g="signatures."+j+".";
function h(n){var p=g+n+".";
var m={};
var o=i.loadParam(p+"count");
if(o!=null){for(var l=0;
l<o;
l++){var q=i.loadParam(p+l+".id");
var k=i.loadParam(p+l+".val");
if(k==null){continue
}m[l]={};
m[l]["id"]=q;
m[l]["value"]=k
}}return m
}function f(){var n=g+"widgets.";
var m=[];
var l=i.loadParam(n+"count");
if(l!=null){for(var k=0;
k<l;
k++){var o={};
o.type=i.loadParam(n+k+".type");
o.title=i.loadParam(n+k+".title");
o.enabled=i.loadParam(n+k+".enabled");
WiseStampUtils.log("[WiseStampMozillaStorage::readApps] "+i.loadParam(n+k+".value")+" >>>");
o.params=WiseStampUtils.jsonParse(i.loadParam(n+k+".value"));
m.push(o)
}}return m
}var e=this.getDefaultSignature(false);
e.title=this.loadParam(g+"title",undefined,"complex");
e.html=this.loadParam(g+"html",undefined,"complex");
e.socialFormat=this.loadParam(g+"socialFormat");
e.socialLabel=this.loadParam(g+"socialLabel",undefined,"complex");
e.imFormat=this.loadParam(g+"imFormat");
e.imLabel=this.loadParam(g+"imLabel");
e.borderType=this.loadParam(g+"borderType");
e.bgColor=this.loadParam(g+"bgColor");
e.socialServices=h("social");
e.imServices=h("im");
e.widgets=f();
return e
};
this.loadVer1=function(e){var k=this;
function i(A){var p={};
p.show={};
p.show.services=e.getCharPref(A+".services","linkedin,facebook,flickr,twitter");
p.show.im=e.getCharPref(A+".im","gtalk,skype,msn");
p.im={};
p.services={};
var z=e.getCharPref("im","aim,bb,gtalk,googlewave,icq,msn,qq,skype,yahoo").split(",");
for(var s=0;
s<z.length;
s++){var w=z[s];
var y="";
y=e.getCharPref(A+"."+w);
p.im[w]=y.split("\r\n");
if(!p.im[w]){p.im[w]=[]
}}var m=e.getCharPref("services","amazon,answers,bebo,blogger,blogRSS,delicious,deviantart,digg,ebay,etsy,facebook,flickr,flixster,friendfeed,friendster,google,googlebuzz,googlecalendar,googlereader,hi5,hyves,lastfm,linkedin,livejournal,meetup,mybloglog,myspace,netflix,netvibes,ning,orkut,photobucket,picasa,plaxo,plurk,reddit,stumbleupon,second_life,seesmic,slideshare,stumbleupon,technorati,tumblr,tungle,twitter,typepad,upcoming,vimeo,visualcv,wordpress,xanga,xing,yanswers,yedda,yelp,youtube").split(",");
for(var s=0;
s<m.length;
s++){var n=m[s];
var y="";
y=e.getCharPref(A+"."+n);
p.services[n]=y.split("\r\n");
if(!p.services[n]){p.services[n]=[]
}}p.text=e.getComplexPref(A+".text");
p.text=p.text.replace(/\\"/gi,'"');
p.advanced=e.getComplexPref(A+".advanced");
p.rsstitle=e.getComplexPref(A+".rss-title");
p.rssurl=e.getComplexPref(A+".rss-url");
p.imFormat={};
p.servicesFormat={};
try{p.imFormat.hideTitle=e.mPrefsBranch.getBoolPref(A+".im.hideTitle");
p.imFormat.title=e.mPrefsBranch.getComplexValue(A+".im.title",Components.interfaces.nsISupportsString).data;
p.imFormat.showLabels=e.mPrefsBranch.getBoolPref(A+".im.showLabels");
p.imFormat.showIcons=e.mPrefsBranch.getBoolPref(A+".im.showIcons");
p.servicesFormat.hideTitle=e.mPrefsBranch.getBoolPref(A+".services.hideTitle");
p.servicesFormat.title=e.mPrefsBranch.getComplexValue(A+".services.title",Components.interfaces.nsISupportsString).data;
p.servicesFormat.showLabels=e.mPrefsBranch.getBoolPref(A+".services.showLabels");
p.servicesFormat.showIcons=e.mPrefsBranch.getBoolPref(A+".services.showIcons")
}catch(u){p.imFormat.hideTitle=e.getBoolPref("hidechat",false);
p.imFormat.title=e.getComplexPref("chat","");
p.imFormat.showLabels=e.getBoolPref("im.text",true);
p.imFormat.showIcons=e.getBoolPref("im.icons",true);
p.servicesFormat.hideTitle=e.getBoolPref("hidecontactme",false);
p.servicesFormat.title=e.getComplexPref("contactme","");
p.servicesFormat.showLabels=e.getBoolPref("services.text",false);
p.servicesFormat.showIcons=e.getBoolPref("services.icons",true)
}var o=k.getDefaultSignature(false);
o.socialServices={};
var x=(p.show.services=="")?[]:p.show.services.split(",");
for(var r=0;
r<x.length;
r++){o.socialServices[r]={};
o.socialServices[r]["id"]=x[r];
o.socialServices[r]["value"]=p.services[x[r]]
}o.imServices={};
var w=(p.show.im=="")?[]:p.show.im.split(",");
for(var v=0;
v<w.length;
v++){o.imServices[v]={};
o.imServices[v]["id"]=w[v];
o.imServices[v]["value"]=p.im[w[v]]
}o.html=p.text;
if(p.servicesFormat.hideTitle==false){o.socialLabel=p.servicesFormat.title
}if(p.imFormat.hideTitle==false){o.imLabel=p.imFormat.title
}o.socialFormat="both";
if(p.servicesFormat.showLabels&&!p.servicesFormat.showIcons){o.socialFormat="text"
}else{if(!p.servicesFormat.showLabels&&p.servicesFormat.showIcons){o.socialFormat="icons"
}}o.imFormat="both";
if(p.imFormat.showLabels&&!p.imFormat.showIcons){o.imFormat="text"
}if(p.rssurl!=""){var q={};
q.id="0";
q.type="rss";
q.title="RSS";
q.enabled="true";
q.params={title:p.rsstitle,url:p.rssurl};
o.widgets=[];
o.widgets.push(q)
}return o
}var j=this.getDefaultData(false);
j.prefs={};
j.prefs.insertOnCompose=e.getBoolPref("autoinsert_compose",true,"autoinsert");
j.prefs.insertOnReply=e.getBoolPref("autoinsert_thread",true,"autoinsert");
j.prefs.displayWebmailIcon=!e.getBoolPref("hidebuttons",false);
j.prefs.displayPlatformIcon=!e.getBoolPref("hidestatusbar",false);
j.prefs.addPromotionTag=e.getBoolPref("promote",true);
j.signatures={};
var l=e.getComplexPref("type","personal");
var f=e.getComplexPref("signatures","Personal,Business").split(",");
for(var h=0;
h<f.length;
h++){var g=encodeURIComponent(f[h].replace(/^\s+|\s+$/,"").toLowerCase());
j.signatures[h+1]=i(g);
j.signatures[h+1].title=f[h];
if(l==g){j.prefs.defaultId=h+1
}}return j
};
this.loadLocal=function(l){WiseStampUtils.log("[WiseStampMozillaStorage::load] >>>");
this.mData=this.getDefaultData(false);
var g=this.loadParam("signaturesIds");
if(g!=null){WiseStampUtils.log("[WiseStampMozillaStorage::load] signatures found");
g=g.split(",");
for(var f in g){var k=g[f];
WiseStampUtils.log("[WiseStampMozillaStorage::load] loading signature ["+k+"]");
this.mData.signatures[k]=this.loadSignature(k)
}var j=this.loadParam("mappings");
this.mData.mappings=this.loadParam("mappings",undefined,"json");
this.mData.customIcons=this.loadParam("customIcons",undefined,"json");
this.mData.version=this.loadParam("version");
this.mData.prefs={};
this.mData.prefs.defaultId=this.loadParam("defaultId");
this.mData.prefs.insertOnCompose=this.loadParam("insertOnCompose");
this.mData.prefs.insertOnReply=this.loadParam("insertOnReply");
this.mData.prefs.insertAboveQuote=this.loadParam("insertAboveQuote");
this.mData.prefs.displayWebmailIcon=this.loadParam("displayWebmailIcon");
this.mData.prefs.displayPlatformIcon=this.loadParam("displayPlatformIcon");
this.mData.prefs.addPromotionTag=this.loadParam("addPromotionTag");
this.mData.prefs.emailAppsTag=this.loadParam("emailAppsTag")
}else{var h=new WiseStampMozillaPrefs("extensions.wisestamp");
var e=h.getCharPref("currentVersion","none");
if(e!="none"){this.mData=this.loadVer1(h)
}else{this.mData=this.getDefaultData(true);
this.mData.version=this.loadParam("version")
}}this.mData.loggedIn=this.loadLocalParam("loggedIn");
this.mData.loginType=this.loadLocalParam("loginType");
this.mData.username=this.loadLocalParam("username");
this.mData.password=this.loadLocalParam("password");
this.mData.plan=this.loadLocalParam("plan");
this.mData.name=this.loadLocalParam("name");
this.mData.fbToken=this.loadLocalParam("fbToken");
this.mData.expiredPlan=this.loadLocalParam("expiredPlan");
this.mData.uid=this.loadParam("uid");
this.mData.promo_id=this.loadParam("promo_id");
this.mData.promo_html=this.loadParam("promo_html");
WiseStampUtils.log("[WiseStampMozillaStorage::load] "+WiseStampUtils.objectKeys(this.mData.signatures).length+" signatures loaded");
l()
};
this.loadSignatureList=function(e){};
this.save=function(f,i){var e="";
for(var h in f.signatures){this.saveSignature(h,f.signatures[h]);
if(e.length>0){e+=","
}e+=h
}this.saveParam("signaturesIds",e);
this.saveParam("customIcons",f.customIcons);
for(var g in f.prefs){this.saveParam(g,f.prefs[g])
}a.flush();
i()
};
this.loadLocalParam=function(e,f){return this.loadParam(e,f)
};
this.saveLocalParam=function(e,f){return this.saveParam(e,f)
};
this.toText=function(){var e=a.toText();
var f=new WiseStampMozillaPrefs("extensions.wisestamp");
e+=f.toText();
delete f;
return e
};
this.setMapping=function(f,e,g){this.saveParam("mappings."+f+".id",e);
this.saveParam("mappings."+f+".ignore",g)
}
};
WiseStampMozillaStorage.prototype=new WiseStampStorageBase;