var WiseStampApp=function(){this.mParams={};
this.mType="not set";
this.mAppName="not set";
this.mAppTitle="not set";
this.mAppSource="not set";
this.mEnabled=true;
this.mFootnote=null;
this.mIcon=null;
this.mIcon16=null;
this.mSupportedStyles={};
this.mIntervalID=null;
this.mRefreshInterval=600000;
this.mRefreshable=false;
this.mID=null;
this.mDataReady=false;
this.mDataStatus=true;
this.mShouldRefresh=false;
this.mRefreshOnStatusChange=false;
this.mOnRefreshData=null;
this.mOnDataReady=null;
this.mCache=null;
this.init=function(){};
this.startRefreshThread=function(){if(this.getEnabled()==false||this.mRefreshable==false){return
}var a=this;
this.mIntervalID=window.setInterval(function(){a.refreshData()
},a.mRefreshInterval)
};
this.stopRefreshThread=function(){if(this.mIntervalID==null){return
}clearInterval(this.mIntervalID);
this.mIntervalID=null
};
this.refreshData=function(){if(typeof this.mOnRefreshData=="function"){this.mOnRefreshData()
}if(this.mRefreshable==false){if(this.mOnDataReady!=null){this.mOnDataReady(true,this.getID())
}return
}var a=this;
this.mDataReady=false;
this.refreshDataInternal(function(b){a.mDataStatus=b;
if(b==false){a.mCache=null
}a.mDataReady=true;
if(a.mOnDataReady!=null){a.mOnDataReady(b,a.getID(),a.getStatusError())
}})
};
this.isDataReady=function(){WiseStampUtils.log("[WiseStampApp::isDataReady] app = "+this.getAppTitle()+", this.mRefreshable = "+this.mRefreshable+" >>>>>");
if(this.mRefreshable==false){return true
}return this.mDataReady
};
this.getDataStatus=function(){WiseStampUtils.log("[WiseStampApp::isDataReady] app = "+this.getAppTitle()+", this.mRefreshable = "+this.mRefreshable+" >>>>>");
return this.mDataStatus
};
this.onRefreshData=function(a){this.mOnRefreshData=a
};
this.onDataReady=function(a){this.mOnDataReady=a
};
this.onParamsChanged=function(a){a()
};
this.getStatusError=function(){var a="Sorry! There was a problem fetching the data. ";
if(this.mLastErrorMsg==undefined){a+="<i> &mdash; Please make sure all details are correct and you are connected to internet.</i>"
}else{a+="<i> &mdash; "+this.mLastErrorMsg+"</i>"
}return a
};
this.setStatusError=function(a){this.mLastErrorMsg=a
};
this.getAppTitle=function(){return this.mAppTitle
};
this.setAppTitle=function(a){this.mAppTitle=a
};
this.getAppSource=function(){return this.mAppSource
};
this.setAppSource=function(a){this.mAppSource=a
};
this.getAppName=function(){return this.mAppName
};
this.setAppName=function(a){this.mAppName=a
};
this.getParams=function(){var a={};
for(var b in this.mParams){a[b]=this.mParams[b].value
}return a
};
this.setParams=function(b,d){for(var c in b){if(typeof this.mParams[c]=="undefined"){continue
}this.mParams[c]["value"]=b[c]
}var a=this;
this.onParamsChanged(function(){a.refreshData();
if(typeof d!="undefined"){d()
}})
};
this.getType=function(){return this.mType
};
this.setType=function(a){this.mType=a
};
this.getEnabled=function(){return this.mEnabled
};
this.setEnabled=function(a){this.mEnabled=a;
if(a==true){this.startRefreshThread()
}else{this.stopRefreshThread()
}};
this.getParam=function(b,a){if(b in this.mParams==false){WiseStampUtils.log("[WiseStampApp::getParam] app = "+this.getAppTitle()+", param = "+b+" undefined!!!");
if(typeof a!="undefined"){return a
}else{return undefined
}}if(this.mParams[b].value==undefined){if(typeof a!="undefined"){return a
}else{return""
}}return this.mParams[b].value
};
this.setParam=function(b,a){if(b in this.mParams==false){WiseStampUtils.log("[WiseStampApp::setParam] app = "+this.getAppTitle()+", param = "+b+" undefined!!!");
return
}this.mParams[b].value=a
};
this.setOptions=function(b,a){if(b in this.mParams==false){return
}this.mParams[b].options=a
};
this.addParam=function(b,a){if(b in this.mParams==true){WiseStampUtils.log("[WiseStampApp::addParam] app = "+this.getAppTitle()+", mParams["+b+"] already exists!!!");
return
}this.mParams[b]={};
this.mParams[b]=a
};
this.getID=function(){return this.mID
};
this.setID=function(a){this.mID=a
};
this.getFootnote=function(){return this.mFootnote
};
this.getIcon=function(a){a=parseInt(a);
if(a==16&&this.mIcon16){return this.mIcon16
}else{if(a==32&&this.mIcon){return this.mIcon
}else{if(a==16){return"../img/widgets/"+this.getType()+".png"
}else{return"../img/widgets/"+this.getType()+"_32.png"
}}}};
this.setIcon=function(a){this.mIcon=a
};
this.setIcon16=function(a){this.mIcon16=a
};
this.setSupportedStyles=function(b){this.mSupportedStyles=b;
for(var a in b){if(this.mSupportedStyles[a].enforcedStyle!=true){var c={type:"checkbox",label:"Use "+a+" style",dockLeft:true};
if(this.mSupportedStyles[a].defaultStyle==true){c.value=true
}a=a+"Style";
this.addParam(a,c)
}}};
this.getSupportedStyles=function(){return this.mSupportedStyles
};
this.getSettingsWidth=function(){return 300
};
this.getSettingsHeight=function(){};
this.getSettingsHtml=function(){return null
};
this.showDialog=function(b,a,d){var c=new WiseStampAppFormDlg(this.getType());
var e=this;
c.show(this,function(f){e.setParams(f,b)
},null,a)
};
this.getTrackingCode=function(a,d,b){var c=[];
c.push("utm_source=WiseStamp");
c.push("utm_medium="+a);
c.push("utm_campaign="+d);
if(typeof b!="undefined"){c.push("utm_term="+b)
}return c.join("&")
};
this.addTrackingCode=function(a,b){if(a.indexOf("?")==-1){a+="?"
}else{a+="&"
}return a+this.getTrackingCode("Email","WiseStampEmailApp",b)
};
this.getBrandingLink=function(){var a=WiseStamp.config.URLs.website.app_brand+"/"+this.getType();
a+="?utm_source=extension&utm_medium=email&utm_term=<apptype>&utm_campaign=apps";
a=a.replace("<apptype>",this.getType());
return a
};
this.getBranding=function(c){if(WiseStampUser.featureSupported("emailAppsTag",true)==true){return""
}if(WiseStampUtils.isEmpty(c)){c={}
}if(WiseStampUtils.isEmpty(c.span)){c.span={}
}if(WiseStampUtils.isEmpty(c.a)){c.a={}
}var a={span:{"text-decoration":"none",background:"white","font-family":"arial,sans-serif",color:"gray","font-size":"80%"},a:{color:"gray","text-decoration":"none"}};
var b={a:"",span:""};
for(var f in c){for(var e in c[f]){a[f][e]=c[f][e]
}c[f]=a[f];
for(var e in c[f]){b[f]+=e+":"+c[f][e]+";"
}}var d='<span style="'+b.span+'">&nbsp;&nbsp;<a href="'+this.getBrandingLink()+'" target="_blank" style="'+b.a+'">Get this email app!&nbsp;</a>&nbsp;</span>';
return d
};
this.getFacebookShare=function(b){b.bUseIcon=(typeof b.bUseIcon!="boolean")?false:b.bUseIcon;
b.linkText=(typeof b.linkText=="undefined"||b.linkText=="")?"Share on Facebook":b.linkText;
b.linkColor=(typeof b.linkColor=="undefined"||b.linkColor=="")?"gray":b.linkColor;
b.linkColor=b.linkColor.replace(";","");
var a="http://www.facebook.com/sharer.php?u="+encodeURIComponent(b.sharedUrl);
if(b.bUseIcon==false){a='<a href="'+a+'" target="_blank" style="color: '+b.linkColor+'; text-decoration: none;">'+b.linkText+"</a>"
}else{a='<a href="'+a+'" target="_blank" style="color: gray; text-decoration: none;"><img src="'+WiseStamp.config.URLs.APIs.images+'apps/facebook-share.png" border="0" width="16px" alt="'+b.linkText+'"></a>'
}return a
};
this.getTwitterShare=function(c){c.bUseIcon=(typeof c.bUseIcon!="boolean")?false:c.bUseIcon;
c.linkText=(typeof c.linkText=="undefined"||c.linkText=="")?"Share on Twitter":c.linkText;
c.linkColor=(typeof c.linkColor=="undefined"||c.linkColor=="")?"gray":c.linkColor;
c.linkColor=c.linkColor.replace(";","");
var a=c.tweetText+" "+(c.sharedUrl||"")+" (via @wisestamp)";
var b="https://twitter.com/intent/tweet?text="+encodeURIComponent(a);
if(c.bUseIcon==false){b='<a href="'+b+'" target="_blank" style="color: '+c.linkColor+'; text-decoration: none;">'+c.linkText+"</a>"
}else{b='<a href="'+b+'" target="_blank" style="color: gray; text-decoration: none;"><img src="'+WiseStamp.config.URLs.APIs.images+'apps/twitter-share.png" border="0" width="16px" alt="'+c.linkText+'"></a>'
}return b
};
this.applyStyle=function(a,b){if(a=="abbreviation"){for(var c=0;
c<b.content.length;
c++){if(b.content[c].text){b.content[c].text=WiseStampUtils.abbreviate(b.content[c].text)
}}}if(a=="compact"){b.borderWidth="0px";
b.borderRightWidth="0px";
b.actionsHtmlStart=" <span";
b.actionsHtmlEnd="</span>";
if(typeof b.contentHtml==="undefined"){if(b.content&&b.content.length>0){for(var c in b.content){b.content[c].text=b.content[c].text.replace(/<br[^>]+>/g," ")
}}}if(b.styles.compact){if(b.styles.compact.icon.source){if(b.styles.compact.icon.source.indexOf("http")==0){b.icon.source=b.styles.compact.icon.source
}else{b.icon.source="http://images.wisestamp.com/apps/"+b.styles.compact.icon.source
}}if(b.styles.compact.icon.width){b.icon.width=b.styles.compact.icon.width
}if(b.styles.compact.actions&&b.styles.compact.actions.preDelimiter&&b.styles.compact.actions.preDelimiter=="none"){if(b.actions&&b.actions.length>0){for(var c=0;
c<b.actions.length;
c++){b.actions[c].preDelimiter="none"
}}}}}return b
};
this.renderHtml=function(i){var x=i;
x.borderWidth="1px";
x.borderRightWidth="1px";
x.actionsHtmlStart="<div";
x.actionsHtmlEnd="</div>";
var y="";
if(this.mSupportedStyles){for(var f in this.mSupportedStyles){var A=WiseStampUtils.pbp(this.mParams,f+"Style.value");
if((A&&A!="0")||this.mSupportedStyles[f].enforcedStyle){x[f]=true;
x=this.applyStyle(f,x)
}}}if(x.icon){if(x.icon.source){if(x.icon.source.indexOf("http")!=0){x.icon.source="http://images.wisestamp.com/apps/"+x.icon.source
}}var h=(x.icon.height)?'height="'+x.icon.height+'" ':"";
var B=(x.icon.width)?'width="'+x.icon.width+'" ':"";
if(x.icon.text){y='<br /><font style="font-size: 80%;" color="gray">'+x.icon.text+"</font>"
}}if(x.twitterLink){x.twitterLink.html=this.getTwitterShare({bUseIcon:false,tweetText:x.twitterLink.tweetText,linkText:x.twitterLink.linkText,linkColor:x.twitterLink.linkColor})
}if(x.facebookLink){x.facebookLink.html=this.getFacebookShare({bUseIcon:false,sharedUrl:x.facebookLink.sharedUrl,linkText:x.facebookLink.linkText,linkColor:x.facebookLink.linkColor})
}if(x.twitterIcon){x.twitterIcon.html=this.getTwitterShare({bUseIcon:true,tweetText:x.twitterIcon.tweetText,linkText:x.twitterIcon.linkText,linkColor:x.twitterIcon.linkColor})
}if(x.facebookIcon){x.facebookIcon.html=this.getFacebookShare({bUseIcon:true,sharedUrl:x.facebookIcon.sharedUrl,linkText:x.facebookIcon.linkText,linkColor:x.facebookIcon.linkColor})
}if(typeof x.contentHtml==="undefined"){x.contentHtml="";
if(x.content&&x.content.length>0){for(var r in x.content){var a="";
var p="";
var w="underline";
if(typeof x.content[r].textDecoration=="string"){var w=x.content[r].textDecoration
}if(x.content[r].text){a=x.content[r].text
}if(x.content[r].color){p="color: "+x.content[r].color+";"
}if(x.content[r].link){a='<a href="'+x.content[r].link+'" style="text-decoration: '+w+";"+p+'" target="_blank">'+a+"</a>"
}else{if(p!=""){a='<span style="'+p+'">'+a+"</span>"
}}x.contentHtml+=a
}}x.contentHtml+="</span>"
}var o=false;
var d=[];
var l='<span style="font-size: 90%; color: gray;">';
var g=" 90%;";
var s=2;
var c=" gray;";
var z="";
if(x.actions&&x.actions.length>0){for(var r=0;
r<x.actions.length;
r++){if(x.actions[r].position!="right"){o=true
}else{d[d.length]=x.actions[r]
}var v="";
var b="";
var u="";
var j=' style="vertical-align: bottom;';
var t="";
t=z;
if(x.actions[r].preDelimiter&&x.actions[r].preDelimiter!="none"){t+=x.actions[r].preDelimiter
}if(x.actions[r].color){v=" color: "+x.actions[r].color+";"
}if(x.actions[r].fontSize){b=" font-size: "+x.actions[r].fontSize+";"
}if(x.actions[r].marginTop&&x.actions[r].marginTop>s){s=x.actions[r].marginTop
}if(x.actions[r].textDecoration){u=" text-decoration:"+x.actions[r].textDecoration+";"
}if((b!=""&&b!=g)||(v!=""&&v!=c)||u!=""){j+=v+b+u
}if(x.actions[r].text){t+=x.actions[r].text
}if(x.actions[r].link){t='<a href="'+x.actions[r].link+'" target="_blank"'+j+'">'+t+"</a>"
}else{t="<span "+j+'">'+t+"</span>"
}if(x.actions[r].position!="right"){if(x.actions[r].delimiter){z=x.actions[r].delimiter
}else{z=""
}l+=t
}else{d[d.length-1].html=t
}}x.actionsHtmlStart=x.actionsHtmlStart+' style="margin-top: '+s+'px;">'
}if(x.facebookLink){l=l+z;
if(x.facebookLink.preDelimiter){l=l+x.facebookLink.preDelimiter
}l=l+x.facebookLink.html;
if(x.facebookLink.delimiter){z=x.facebookLink.delimiter
}else{z=""
}o=true
}if(x.twitterLink){l=l+z;
if(x.twitterLink.preDelimiter){l=l+x.twitterLink.preDelimiter
}l=l+x.twitterLink.html;
o=true
}z="&#8197;";
var k="";
if(x.facebookIcon||x.twitterIcon){k='</td><td style="text-align: right; vertical-align: top; white-space: nowrap; font: inherit;">'
}else{if(d.length>0){k='</td><td style="text-align: right; vertical-align: middle; white-space: nowrap; font: inherit;">'
}}if(x.facebookIcon){if(x.facebookIcon.preDelimiter){k=k+x.facebookIcon.preDelimiter
}k=k+x.facebookIcon.html;
if(x.facebookIcon.delimiter){z=x.facebookIcon.delimiter
}}if(x.twitterIcon){if(x.facebookIcon){k=k+z
}if(x.twitterIcon.preDelimiter){k=k+x.twitterIcon.preDelimiter
}k=k+x.twitterIcon.html
}if(d.length>0){for(var r=0;
r<d.length;
r++){if(x.facebookIcon||x.twitterIcon){k=k+z
}k=k+d[r].html
}}if(o&&!(x.actions&&x.actions.length>0)){l=" "+l+"</span>"
}else{if(o){l=x.actionsHtmlStart+l+"</span>"+x.actionsHtmlEnd
}else{l=""
}}var q='<span style="float: right; padding-right: 0.5em;">'+this.getBranding()+"</span>";
var e=" background-color: white";
if(typeof x.compact&&x.compact==true){q="";
e=""
}var m='<div style="border: '+x.borderWidth+" solid #aaaaaa; margin: "+this.APP_MARGINS+"; padding-bottom: 0.5em;"+e+'"><table width="100%" style="border: 0; font-size: 80%; padding: 3px 3px 0 3px;" cellpadding="0" cellspacing="0" ><tr valign="top"><td width="1" style="padding-top: 3px; padding-left: 3px; padding-right: 6px; border-right: '+x.borderRightWidth+' solid #e5e5e5; text-align: center; font: inherit;"><a style="color: #d1d1d1;" href="'+x.icon.link+'" target="_blank"><span style="font-size: 200%; color: #d1d1d1;"><img '+h+" "+B+'" border="0" alt="'+this.getAppName()+'" src="'+x.icon.source+'" ></span></a>'+y+'</td><td style="padding: 1px 8px 0px 8px; font: inherit;">'+x.contentHtml+l+k+"</td></tr></table>"+q+"</div>";
return(m)
};
this.buildHtmlBoxBorder=function(c,b){var b=b||"1px";
var a=(WiseStamp.sys.application=="IE")?"font-size: 1em;":"font-size: 80%;";
return'<div style="border: '+b+' solid #aaaaaa; padding-bottom: 0.5em; background: white;"><table width="100%" style="border: 0; padding: 3px 3px 0 3px; '+a+'" cellpadding="0" cellspacing="0" ><tr valign="top">'+c+'</tr></table><span style="float: right; padding-right: 0.5em;">'+this.getBranding()+"</span></div>"
};
this.buildHtmlBox=function(k,j,i,c,l,b,h){var b=b||"defaultStyle";
var c=c||"32";
var f=(typeof l==="undefined")?"":' height="'+l+'px" ';
var d=(k.indexOf("http")==0);
var k=d?k:WiseStamp.config.URLs.APIs.images+"apps/"+k;
var h=h||"noIconText";
if(h!="noIconText"){h="<br /><font style='font-size: 80%;' color='gray'>"+h+"</font>"
}else{h=""
}var g="1px";
var a="1px";
if(b=="compactStyle"){a="0px";
g="0px"
}var e='<td width=1% style="padding: 2px 6px 1px 3px; border-right: '+a+' solid #e5e5e5; text-align: center; font: inherit;"><a style="color: #d1d1d1;" href="'+j+'" target="_blank"><span style="font-size: 200%; color: #d1d1d1;"><img '+f+"width="+c+'px border=0 alt="'+this.getAppName()+'" src="'+k+'" ></span></a>'+h+'</td><td style="padding: 1px 8px 0px 8px; font: inherit;">'+i+"</td>";
return this.buildHtmlBoxBorder(e,g)
}
};