tinyMCEPopup.requireLangPack();

var chars = [
		'✉','☎','✎','©','®','™',
		'$','€','•','✔','✖','☑','☒',
		'☺','✍','☛','☚','☞','☜',
		'✿','❀','❂','♥','☯','☼',
		'★','♫','♙','♟','☊'];

	
function select(element)
{
	//$('table#chars td').removeClass('selected');
	//$(element).addClass('selected');
	selectedValue = $(element).text();
	
	wsSpecialCharsDialog.insert(selectedValue);
}


var wsSpecialCharsDialog = {
	init : function() {
	
		var table = $('table#chars');
		var iChar = 0; 
		while (iChar < chars.length)
		{
			var row = $('<tr />');
			for (var iColumn = 0; iColumn < 6; iColumn++)
			{
				if (iChar >= chars.length)
					break;
				
				var cell = $('<td>'+chars[iChar]+'</td>');
				cell.click(function(){select(this)});
				cell.mouseover(function(){
						$('table#chars td').removeClass('selected'); 
						$(this).addClass('selected');
					});

				row.append(cell);
				iChar++;
			}
			
			table.append(row);
		}
		
		document.getElementById('special_form').addEventListener("submit",function(){wsSpecialCharsDialog.insert(); return false;},false);
	
		//var f = document.forms[0];

		// Get the selected contents as text and place it in the input
		//f.someval.value = tinyMCEPopup.editor.selection.getContent({format : 'text'});
		//f.somearg.value = tinyMCEPopup.getWindowArg('some_custom_arg');
	},

	insert : function(char) {
		// Insert the contents from the input into the document
		// tinyMCEPopup.editor.execCommand('mceInsertContent', false, char);
		
		if (navigator.userAgent.indexOf("MSIE") != -1)
		{
			// in IE the regular insertion puts the content at the
			// beginning, rather than at the cursor (due to lost focus).
			// solution from http://tinymce.moxiecode.com/forum/viewtopic.php?id=20820
			// [sasha]
			var inst = tinyMCEPopup.editor;
			//var elm = inst.selection.getNode();
			//i = inst.selection.getBookmark();
			var bookmark = tinyMCEPopup.getWindowArg('bookmark');
			inst.selection.moveToBookmark(bookmark);
			
			tinyMCEPopup.execCommand('mceInsertContent',false,char);
			
		} else {
			tinyMCEPopup.editor.execCommand('mceInsertContent', false, char);
		}
		
		tinyMCEPopup.close();
	}
};

tinyMCEPopup.onInit.add(wsSpecialCharsDialog.init, wsSpecialCharsDialog);
